{$A+,B-,D+,E-,F-,I-,L+,N+,O-,R-,S-,V-,G-}
{$M 16384,0,655360}

{Analyze analyses data from a data file having the form :Flag, Runs, years
data...}


USES Graph,Global,Crt,Linlib,Utility,Math,ScrLib,PrintSc2,MeanOcc,SumStat,
     VGAPal,LaserPr;

CONST
     MaxYears = 500;
     DataFlag = -7777;
     FirstTime : Boolean = True;
TYPE
    IntArray      = Array[1..MaxYears] OF Integer;
    DataPtr       = ^RealDataArray;
    TextBuffer    = Array[0..65534] OF Byte;
    BuffPtr       = ^TextBuffer;
    ColorArr      = Array[1..9] OF Byte;
    StyleArr      = Array[1..8] OF Byte;
    TitleArr      = Array[1..7] OF String[40];
    CharSet       = Set OF Char;
    Menu = RECORD
                 StartX,StartY         : Byte;
                 BackAtt,TextAtt,HiAtt,
                 N                     : Byte;
                 PosArr                : Array[1..5] OF Byte;
                 StrArr                : Array[1..5] OF String[39];
                 LetterSet             : CharSet;
           END;
VAR
   Pop,Juv,Adult,Pair,
   IdentByDescent,
   PopSD,JuvSD,AdultSD,PairSD,
   IdentByDescentSD                          : DataPtr;
   NSize                                     : IntArray;
   Inp                                       : Text;
   EscSw,PrinterOn                           : Boolean;
   Buff                                      : BuffPtr;
   GlobRuns,Years,MinPop,ExtinctNo           : Word;
   MeanExtTime,MeanDeathDist,MeanPairDist    : Single;


{*************************Graphics}

CONST
     OwlColor : ColorArr   = (Yellow,LightRed,White,LightGray,LightCyan,LightMagenta,
                              LightBlue,LightBlue,LightGreen);
     OwlTitle : TitleArr   = (' TOTAL',' ADULT ',' JUVENILE ',' PAIR ',
                              ' IDENTICAL BY DESCENT ','','');
     OutTitle : TitleArr   = (' TOTAL','ADULT','JUVENILE','PAIR',
                              'ID. GENES','','');
     Device : Integer = 0;
     Mode   : Integer = 0;

PROCEDURE ScaleAxes(      N      : Word;
                    VAR Arr      : RealDataArray;
                    VAR IntArr   : IntArray;
                    VAR MaxVal   : Single;
                    VAR ScaleVal : Single;
                    ScaleTo      : Word);
          VAR
             Ct : Word;
          BEGIN
               IF N = 0 THEN Exit;
               MaxVal := Max(n,Arr);
               IF MaxVal > 0 THEN
                  ScaleVal := ScaleTo/MaxVal
               ELSE
                   ScaleVal := 0;
               RoundAndScaleRow(N,ScaleVal,Arr,IntArr);
               FOR Ct := 1 TO N DO
                   IF IntArr[Ct] < 0 THEN
                      IntArr[Ct] := 0;
END;
PROCEDURE DrawHashMarks(PosX,PosY,Number : Word;Vertical : Boolean);
          VAR
             St : String[2];
          BEGIN

               IF Vertical THEN BEGIN
                  Str(Number:2,St);
                  Line(PosX-3,PosY,PosX+3,PosY);
                  OutTextXY(PosX-12,PosY,St);
               END
               ELSE BEGIN
                    Str(Number,St);
                    Line(PosX,PosY + 3,PosX,PosY-3);
                    OutTextXY(PosX,PosY + 12,St);
               END;
END;
PROCEDURE SeparateExponent(N : Single;VAR Mant : Single;VAR Exp : ShortInt);
          VAR
             St : String[30];
             s  : Integer;
          BEGIN
               Str(N,St);
               Exp := Byte(St[Byte(St[0])]); {last letter}
               Dec(Exp,48);
               IF St[Length(St) - 4] = '-' THEN
                  Exp := -Exp;
               Val(Copy(St,1,5),Mant,s);     {3 decimal places}
               IF Mant < 2 THEN BEGIN
                     Dec(Exp);
                     Mant := Mant * 10;
               END;
END;
PROCEDURE CreateAxes(Time                       : Word;
                     VAR XTitle,YTitle          : String;
                     MaxY,ScaleX,ScaleY         : Single;
                     StartX,StartY              : Word);
          VAR
             XLabel,YLabel     : String[9];
             YExponent,
             XExponent         : ShortInt;
             XMantissa,
             YMantissa         : Single;
             StopX,StopY       : Integer;
             AxisScaleX,
             AxisScaleY        : Single;
             RoundUpX,RoundUpY : Byte;
             Ct                : Word;
          BEGIN
               YLabel := '';
               SeparateExponent(MaxY,YMantissa,YExponent);
               CASE YExponent OF
                    3 : YLabel := 'x 1000';
                    2 : YLabel := 'x 100';
                    1 : YLabel := 'x 10';
                   -1 : YLabel := 'x 0.1';
                   -2 : YLabel := 'x 0.01';
                   -3 : YLabel := 'x 0.001';
                   -4 : YLabel := 'x 0.0001';
               END;

               XLabel := '';
               SeparateExponent(Time,XMantissa,XExponent);
               CASE XExponent OF
                    3 : XLabel := 'x 1000';
                    2 : XLabel := 'x 100';
                    1 : XLabel := 'x 10';
                   -1 : XLabel := 'x 0.1'
               END;
               AxisScaleX := XToTheY(10,XExponent) * ScaleX;
               AxisScaleY := XToTheY(10,YExponent) * ScaleY;
               RoundUpX := Trunc(XMantissa + 0.5);
               RoundUpY := Trunc(YMantissa + 0.5);
               StopY := StartY - Round(RoundUpY * AxisScaleY);
               IF StopY < 10 THEN BEGIN
                  StopY := 10;
                  Dec(RoundUpY);
               END;
               StopX := StartX + Round(RoundUpX * AxisScaleX);
               IF StopX > GetMaxX THEN BEGIN
                  StopX := GetMaxX - 10;
                  Dec(RoundUpX);
               END;
               SetColor(LightCyan);
               SetLineStyle(0,0,1);
               Line(StartX,StartY,StartX,StopY);
               Line(StartX,StartY,StopX,StartY);
               SetTextJustify(1,1);
               OutTextXY(StartX - 12,StartY + 12,'0'); {Origin}
               FOR Ct := 1 TO RoundUpX DO
                   DrawHashMarks(StartX + Round(Ct * AxisScaleX),StartY,Ct,FALSE);
               FOR Ct := 1 TO RoundUpY DO
                   DrawHashMarks(StartX,StartY - Round(Ct * AxisScaleY),Ct,TRUE);
               SetColor(White);
               OutTextXY(GetMaxX SHR 1,GetMaxY-10,XTitle + ' ('+ XLabel + ')');
               SetTextStyle(0,1,1);
               OutTextXY(10,GetMaxY SHR 1,YTitle + ' (' + YLabel + ')');
               SetTextStyle(0,0,1);
END;
PROCEDURE GraphLegend(    Start,N  : Byte;
                      VAR Colors   : ColorArr;
                          Styles   : Byte;
                      VAR Titles   : TitleArr);
         VAR
            Ct : Byte;
         BEGIN
              MoveTo(280,10);
              SetTextStyle(0,0,1);
              SetTextJustify(0,1);
              FOR Ct := Start TO Pred(Start + N) DO BEGIN
                  SetColor(LightCyan);
                  OutText(Titles[Ct]);
                  SetColor(Colors[Ct]);
                  SetLineStyle(0,0,Styles);
                  LineTo(GetX + 20,GetY);
              END;
END;
PROCEDURE DrawGraph(    Time          : Word;
                    VAR YVect         : RealDataArray;
                    XTitle,YTitle     : String;
                        LineOn        : Boolean;
                        Color         : Byte;
                        Style         : Byte;
                    VAR ScaleX,ScaleY : Single;
                    VAR Error         : Boolean);
          VAR
             IntYArr   : IntArray;
             GphX,GphY,
             Ct,DistX,
             DistY,
             StartX,StartY    : Word;
             MaxVal           : Single;
          BEGIN
               DistY := Round(0.75 * GetMaxY);
               DistX := Round(0.75 * GetMaxX);
               StartX := Round(GetMaxX * 0.1);
               StartY := Round(GetMaxY * 0.9);
               ScaleAxes(Time,YVect,IntYArr,MaxVal,ScaleY,DistY);
               ScaleX := DistX/Time;
               Error := ScaleX < 1;
               IF Error THEN
                  Exit;
               CreateAxes(Time,XTitle,YTitle,MaxVal,ScaleX,ScaleY,StartX,StartY);
               SetColor(Color);
               SetLineStyle(0,0,Style);
               MoveTo(StartX,StartY - IntYArr[1]);
               IF LineOn THEN
                  FOR Ct := 2 TO Time DO
                     LineTo(StartX + Round(Pred(Ct) * ScaleX),StartY - IntYArr[Ct])
               ELSE
                   FOR Ct := 2 TO Time DO
                    PutPixel(StartX + Round(Pred(Ct) * ScaleX),StartY - IntYArr[Ct],White);
END;
PROCEDURE AdditionalLines(    Time          : Word;
                          VAR YVect         : RealDataArray;
                              LineOn        : Boolean;
                              Color         : Byte;
                              Style         : Byte;
                              ScaleX,ScaleY : Single);
          VAR
             IntYArr   : IntArray;
             GphX,GphY,
             Ct,DistX,
             DistY,
             StartX,StartY    : Word;
             MaxVal,Dummy     : Single;
          BEGIN
               DistY := Round(0.75 * GetMaxY);
               StartX := Round(GetMaxX * 0.1);
               StartY := Round(GetMaxY * 0.9);
               RoundAndScaleRow(Time,ScaleY,YVect,IntYArr);
               FOR Ct := 1 TO Time DO
                   IF IntYArr[Ct] < 0 THEN
                      IntYArr[Ct] := 0;
               SetColor(Color);
               SetLineStyle(0,0,Style);
               MoveTo(StartX,StartY - IntYArr[1]);
               IF LineOn THEN
                  FOR Ct := 2 TO Time DO
                     LineTo(StartX + Round(Pred(Ct) * ScaleX),StartY - IntYArr[Ct])
               ELSE
                   FOR Ct := 2 TO Time DO
                    PutPixel(StartX + Round(Pred(Ct) * ScaleX),StartY - IntYArr[Ct],White);
END;
PROCEDURE CallGraph(YrCtr : Word);
          VAR
             Err               : Boolean;
             Ct                : Word;
             ScaleY,ScaleX     : Single;
             Ch,Ch2            : Char;
VAR
   Data    : RealDataArray;
   LoopCtr : Byte;
   test    : integer;
LABEL
     LOOP;
BEGIN
     IF Device = 0 THEN BEGIN
        InitGraph(Device,Mode,'');
     test := graphresult;
        IF GraphResult <> 0 THEN
           FatalErrors(1);
        GraphOn := TRUE;
      END
      ELSE
          SetGraphMode(Mode);
      if Device = 9 then
         ChangePalette(Normal);
   LoopCtr := 0;
   REPEAT
      CASE LoopCtr OF
           0 : BEGIN
                  MoveRow(Pop^,Data,YrCtr);
                  AddRows(YrCtr,Data,PopSD^);
                  GraphLegend(1,1,OwlColor,3,OwlTitle);
                  DrawGraph(YrCtr,Data,'TIME IN YEARS','POPULATION',
                            TRUE,OwlColor[1],1,ScaleX,ScaleY,Err);
                  AdditionalLines(YrCtr,Pop^,TRUE,OwlColor[1],3,ScaleX,ScaleY);
                  MoveRow(Pop^,Data,YrCtr);
                  SubRows(YrCtr,Data,PopSD^);
                  AdditionalLines(YrCtr,Data,TRUE,OwlColor[1],1,ScaleX,ScaleY);
               END;
           1 : BEGIN
                  MoveRow(Adult^,Data,YrCtr);
                  AddRows(YrCtr,Data,AdultSD^);
                  GraphLegend(2,1,OwlColor,3,OwlTitle);
                  DrawGraph(YrCtr,Data,'TIME IN YEARS','POPULATION',
                            TRUE,OwlColor[2],1,ScaleX,ScaleY,Err);
                  AdditionalLines(YrCtr,Adult^,TRUE,OwlColor[2],3,ScaleX,ScaleY);
                  MoveRow(Adult^,Data,YrCtr);
                  SubRows(YrCtr,Data,AdultSD^);
                  AdditionalLines(YrCtr,Data,TRUE,OwlColor[2],1,ScaleX,ScaleY);
               END;
           2 : BEGIN
                  MoveRow(Juv^,Data,YrCtr);
                  AddRows(YrCtr,Data,JuvSD^);
                  GraphLegend(3,1,OwlColor,3,OwlTitle);
                  DrawGraph(YrCtr,Data,'TIME IN YEARS','POPULATION',
                            TRUE,OwlColor[3],1,ScaleX,ScaleY,Err);
                  AdditionalLines(YrCtr,Juv^,TRUE,OwlColor[3],3,ScaleX,ScaleY);
                  MoveRow(Juv^,Data,YrCtr);
                  SubRows(YrCtr,Data,JuvSD^);
                  AdditionalLines(YrCtr,Data,TRUE,OwlColor[3],1,ScaleX,ScaleY);
               END;
           3 : BEGIN
                  MoveRow(Pair^,Data,YrCtr);
                  AddRows(YrCtr,Data,PairSD^);
                  GraphLegend(4,1,OwlColor,3,OwlTitle);
                  DrawGraph(YrCtr,Data,'TIME IN YEARS','POPULATION',
                            TRUE,OwlColor[4],1,ScaleX,ScaleY,Err);
                  AdditionalLines(YrCtr,Pair^,TRUE,OwlColor[4],3,ScaleX,ScaleY);
                  MoveRow(Pair^,Data,YrCtr);
                  SubRows(YrCtr,Data,PairSD^);
                  AdditionalLines(YrCtr,Data,TRUE,OwlColor[4],1,ScaleX,ScaleY);
               END;

            4: BEGIN
                  MoveRow(IdentByDescent^,Data,YrCtr);
                  AddRows(YrCtr,Data,IdentByDescentSD^);
                  GraphLegend(5,1,OwlColor,3,OwlTitle);
                  DrawGraph(YrCtr,Data,'TIME IN YEARS','FRACTION IDENTICAL BY DESCENT',
                            TRUE,OwlColor[9],1,ScaleX,ScaleY,Err);
                  AdditionalLines(YrCtr,IdentByDescent^,TRUE,OwlColor[9],3,ScaleX,ScaleY);
                  MoveRow(IdentByDescent^,Data,YrCtr);
                  SubRows(YrCtr,Data,IdentByDescentSD^);
                  AdditionalLines(YrCtr,Data,TRUE,OwlColor[9],1,ScaleX,ScaleY);
               END;
      END;
               GetKeys(Ch,Ch2);
               case ch2 of
                    #25 : PrintScreen(FALSE,Device,Err);
                    #38 : PrintScreen(TRUE,Device,Err);
                    #31 : LaserPrintScreen(Device,Err);
                    #17 : LaserLandscapePrintScreen(Device,Err);
                    ELSE BEGIN
                         LoopCtr := Succ(LoopCtr) MOD 5;
                         ClearDevice;
                    END;
               end;
  UNTIL Ch = #27;
  RestoreCrtMode;
END;


{**************************************File Input and data manipulation}


PROCEDURE Wait;
          BEGIN
               Clrscr;
               FastWrite(148,79 + Blink,' WAIT ');
END;

FUNCTION CheckFile(VAR Inf : Text) : Boolean;
          VAR
             x : Integer;
          BEGIN
               ReadLn(Inf,x);
               Checkfile := (x = DataFlag);
END;
PROCEDURE InitializeVectors;
          BEGIN
               New(Pop);
               New(Juv);
               New(Adult);
               New(Pair);
               New(IdentByDescent);
               New(PopSD);
               New(JuvSD);
               New(AdultSD);
               New(PairSD);

               New(IdentByDescentSD);
               ZeroFill(Pop^,SizeOf(RealDataArray));
               ZeroFill(Juv^,SizeOf(RealDataArray));
               ZeroFill(Adult^,SizeOf(RealDataArray));
               ZeroFill(Pair^,SizeOf(RealDataArray));
               ZeroFill(IdentByDescent^,SizeOf(RealDataArray));
               ZeroFill(PopSD^,SizeOf(RealDataArray));
               ZeroFill(JuvSD^,SizeOf(RealDataArray));
               ZeroFill(AdultSD^,SizeOf(RealDataArray));
               ZeroFill(PairSD^,SizeOf(RealDataArray));
               ZeroFill(IdentByDescentSD^,SizeOf(RealDataArray));
               ZeroFill(NSize,SizeOf(NSize));
END;
PROCEDURE GetMean(VAR Inf : Text;VAR Years : Word);
          VAR
             Ct1,Ct2,Runs, maxstage          : Word;
             Yr,j,a,p,t, sa        : Word;
             Ma,Ibd                : Single;
             Temp                  : Extended;
          BEGIN
               ReadLn(Inf,Runs,Years,maxstage);
               GlobRuns := Runs;
               IF Years > MaxYears THEN BEGIN
                  WriteLn('Data size too large');
                  Close(Inf);
                  Halt;
               END;
               FOR Ct1 := 1 TO Runs DO BEGIN
                   FOR Ct2 := 1 TO Years DO BEGIN
                       ReadLn(Inf,Yr,j,a,sa,p,t,Ibd);
                       Juv^[Ct2] := Juv^[Ct2] + j;
                       Adult^[Ct2] := Adult^[Ct2] + a;
                       Pair^[Ct2] := Pair^[Ct2] + p;
                       Pop^[Ct2]  := Pop^[Ct2] + t;

                       IdentByDescent^[Ct2] := IdentByDescent^[Ct2] + Ibd;
                   END;
                END;
                Close(Inf);
                Temp := 1/Runs;
                MulConst(Years,Temp,Juv^);
                MulConst(Years,Temp,Adult^);
                MulConst(Years,Temp,Pair^);
                MulConst(Years,Temp,Pop^);


                MulConst(Years,Temp,IdentByDescent^);
END;
PROCEDURE VectSqrt(N : Word; VAR Vect : RealDataArray);
          VAR
             Ct : Word;
          BEGIN
               FOR Ct := 1 TO N DO
                   Vect[Ct] := Sqrt(Vect[Ct]);
END;
PROCEDURE GetStd(VAR Inf : Text);
          VAR
             Ct1,Ct2,Runs,Years,laststage    : Word;
             Yr,j,a,p,t,Fl,Jd,Ad,sa   : Word;
             Flag                  : Integer;
             Ma,Ibd                : Single;
             Temp                  : Extended;
          BEGIN
               ReSet(Inf);
               ReadLn(Inf,Flag);
               ReadLn(Inf,Runs,Years,laststage);
               FOR Ct1 := 1 TO Runs DO BEGIN
                   FOR Ct2 := 1 TO Years DO BEGIN
                        ReadLn(Inf,Yr,j,a,sa,p,t,Ibd);
                       JuvSD^[Ct2] := JuvSD^[Ct2] + Sqr(Juv^[Ct2] - j);
                       AdultSD^[Ct2] := AdultSD^[Ct2] + Sqr(Adult^[Ct2] - a);
                       PairSD^[Ct2] := PairSD^[Ct2] + Sqr(Pair^[Ct2] - p);
                       PopSD^[Ct2]  := PopSD^[Ct2] + Sqr(Pop^[Ct2] - t);


                       IdentByDescentSD^[Ct2] := IdentByDescentSD^[Ct2] +
                                                 Sqr(IdentByDescent^[Ct2]-Ibd);
                   END;
                END;
                Close(Inf);
                Temp := 1/Pred(Runs);
                MulConst(Years,Temp,JuvSD^);
                MulConst(Years,Temp,AdultSD^);
                MulConst(Years,Temp,PairSD^);
                MulConst(Years,Temp,PopSD^);


                MulConst(Years,Temp,IdentByDescentSD^);
                VectSqrt(Years,JuvSD^);
                VectSqrt(Years,AdultSD^);
                VectSqrt(Years,PairSD^);
                VectSqrt(Years,PopSD^);

                VectSqrt(Years,IdentByDescentSD^);
END;

{**************************************Program IO}

CONST
    OutRed : Menu = (StartX   : 33;
                     StartY   : 11;
                     BackAtt  : 7;
                     TextAtt  : 7;
                     HiAtt    : 15;
                     N        : 5;
                     PosArr   : (11,11,1,1,1);
                     StrArr   : ('output to File',
                                 'output to Printer',
                                 'Graphic output','Mean occupancy',
                                 'Summary statistics');
                     LetterSet : ['F','P','G','M','S',#27]);

FUNCTION ReturnLetter(Chrs : CharSet) : Char;
         VAR
            Ch,Ch2 : Char;
         BEGIN
              REPEAT
                    GetKeys(Ch,Ch2);
                    Ch := Upcase(Ch);
              UNTIL Ch IN Chrs;
              ReturnLetter := Ch;
END;
FUNCTION InputMenu(VAR M : Menu) : Char;
          VAR
             Posit               : Word;
             Ct,SaveAtt,TempY    : Byte;
          BEGIN
               SetCursorSize(NoCursor);
               WITH M DO BEGIN
                    TempY := StartY;
                    SaveAtt  := TextAttr;
                    TextAttr := BackAtt;
                    ClrScr;
                    Posit := GetScrPos(StartX,StartY);
                    FOR Ct := 1 TO N DO BEGIN
                        HighLightWrite(StartX,TempY,PosArr[Ct],TextAtt,
                                       HiAtt,StrArr[Ct]);
                        Inc(TempY);
                    END;
                    CenterText(24,BackAtt,'Hit <ESC> to exit program');
                    InputMenu := ReturnLetter(LetterSet);
               END;
               TextAttr := SaveAtt;
               SetCursorSize(Cursor);
END;

FUNCTION MakeDashedLine : String;
         VAR
            TempSt : String;
        BEGIN
             FillChar(TempSt[1],130,'-');
             TempSt[0] := #130;
             MakeDashedLine := Tempst;
END;
FUNCTION MakeStringfield(St : String;FieldWidth : Byte):String;
         VAR
            TempSt : String;
            Ct,Ctr : Byte;
         BEGIN
              FillChar(TempSt[1],FieldWidth,#32);
              TempSt[0] := Char(FieldWidth);
              IF Byte(St[0]) > FieldWidth THEN
                 St[0] := Char(FieldWidth);
              Ctr := Succ(Byte(St[0]));
              FOR Ct := FieldWidth DOWNTO (FieldWidth - Pred(Byte(St[0]))) DO
                  BEGIN
                  Dec(Ctr);
                  TempSt[Ct] := St[Ctr];
              END;
              MakeStringField := TempSt;

END;
FUNCTION MakeRealField(Mean,Std : Single;Field : Word):String;
         VAR
            TempSt,TempSt2 : String;
            Decimals       : Word;
         BEGIN
              IF Mean >= 1000 THEN
                 Decimals := 0
              ELSE IF Mean >= 100 THEN
                 Decimals := 1
              ELSE IF Mean < 1 THEN
                   Decimals := 3
              ELSE
                  Decimals := 2;
              Str(Mean:5:Decimals,TempSt);
              IF Std >= 1000 THEN
                 Decimals := 0
              ELSE IF Std >= 100 THEN
                 Decimals := 1
              ELSE IF Std < 1 THEN
                   Decimals := 3
              ELSE
                  Decimals := 2;
              Str(Std:5:Decimals,TempSt2);
              MakeRealField := MakeStringField(TempSt +' '+TempSt2,Field);
END;
FUNCTION MakeCenteredString(St : String):String;
         VAR
            TempSt : String;
            Start  : Byte;
            Ct,Ctr : Byte;
         BEGIN
              IF St[0] > #132 THEN
                 St[0] := #132;
              Start := (135 - Byte(St[0])) SHR 1;
              FillChar(TempSt[1],135,#32);
              TempSt[0] := Char(Start + Pred(Byte(St[0])));
              Ctr := 0;
              FOR Ct := Start TO (Pred(Start) + Byte(St[0])) DO BEGIN
                  Inc(Ctr);
                  TempSt[Ct] := St[Ctr];
              END;
              MakeCenteredString := TempSt;
END;
FUNCTION MakeCenteredString2(St : String):String;
         VAR
            TempSt : String;
            Start  : Byte;
            Ct,Ctr : Byte;
         BEGIN
              IF St[0] > #78 THEN
                 St[0] := #78;
              Start := (80 - Byte(St[0])) SHR 1;
              FillChar(TempSt[1],80,#32);
              TempSt[0] := Char(Start + Pred(Byte(St[0])));
              Ctr := 0;
              FOR Ct := Start TO (Pred(Start) + Byte(St[0])) DO BEGIN
                  Inc(Ctr);
                  TempSt[Ct] := St[Ctr];
              END;
              MakeCenteredString2 := TempSt;
END;
PROCEDURE StartDataType(VAR Outf  : Text;
                            St    : String;
                            Arr   : TitleArr;
                            N     : Byte;
                            Field : Byte);
          VAR
             Ct : Byte;
          BEGIN
          WriteLn(OutF,MakeDashedLine);
          Write(OutF,MakeStringField(St,Field));
          FOR Ct := 1 TO N DO
              Write(OutF,MakeStringField(Arr[Ct],Field));
          WriteLn(OutF,'');
          WriteLn(OutF,MakeDashedLine);
END;
PROCEDURE WriteNameAndComment(Name,Comment : String;VAR OutF : Text);
          VAR
             Ct : Word;
          BEGIN
               FOR Ct := 1 TO 20 DO
                   WriteLn(OutF);
               WriteLn(OutF,MakeCenteredString2(Name));
               WriteLn(OutF);
               WriteLn(OutF,Comment);
               IF PrinterOn THEN
                  WriteLn(OutF,#12);
END;
PROCEDURE FullData(VAR OutF : Text;YrCtr : Word);
          VAR
             Ct    : Word;
             Field : Word;
          BEGIN
               Field := 135 DIV 10;
               WriteLn(OutF,MakeCenteredString('CUMULATIVE YEARLY DATA'));
               WriteLn(OutF);
               StartDataType(Outf,'YEAR',OutTitle,9,Field);
               FOR Ct := 1 TO YrCtr DO BEGIN
                  Write(OutF,Ct:Field);
                  Write(OutF,MakeRealField(Pop^[Ct],PopSD^[Ct],Field));
                  Write(OutF,MakeRealField(Juv^[Ct],JuvSD^[Ct],Field));
                  Write(OutF,MakeRealField(Adult^[Ct],AdultSD^[Ct],Field));
                  Write(OutF,MakeRealField(Pair^[Ct],PairSD^[Ct],Field));
                  Write(OutF,MakeRealField(IdentByDescent^[Ct],identbydescent^[Ct],Field));
                  WriteLn(OutF);
               END;
END;
PROCEDURE OutputRules(FileName : String;VAR OutF2 : Text);
          VAR
             OutF : Text;
             St   : String;
             LastCh : Byte;
          BEGIN
               LastCh := LastCharPos('.',FileName);
               IF LastCh <> 0 THEN
                  FileName[0] := Char(Pred(LastCh));
               FileName := FileName + '.QZX';
               Assign(OutF,FileName);
               ReSet(OutF);
               IF IOResult <> 0 THEN
                  FatalErrors(6);
               WHILE NOT Eof(OutF) DO BEGIN
                     ReadLn(OutF,St);
                     WriteLn(OutF2,St);
               END;
               Close(OutF);
END;
PROCEDURE OutputToFile(VAR OutF : Text;YrCtr : Word);
          VAR
             RunName,Comment : String;
          BEGIN
               ClrScr;
               RunName := '';
               SlowWrite(1,11,'The title : ');
               ReadLn(RunName);
               Comment := '';
               WriteLn;
               WriteLn('Any comments : ');
               ReadLn(Comment);
               ClrScr;
               WriteNameAndComment(RunName,Comment,OutF);
               OutputRules(GlobInpFileName,OutF);
               ReadSumStatsFile(MeanExtTime,
                                MeanDeathDist,
                                MeanPairDist,
                                MinPop,ExtinctNo,
                                GlobInpFileName);
               ProduceSummaryStats(GlobRuns,YrCtr,Pop^,MeanExtTime,
                                   ExtinctNo,MinPop,
                                   MeanDeathDist,MeanPairDist,OutF,
                                   PrinterOn);
               IF PrinterOn THEN
                  Write(OutF,#15);      {Set Compressed Mode}
               FullData(OutF,YrCtr);
               IF PrinterOn THEN BEGIN
                  Write(OutF,#12);
                  Write(OutF,#18);     {Cancel compressed mode}
               END;
               Close(OutF);
END;
PROCEDURE ChooseOutputForm(VAR EscSw : Boolean;YrCtr : Word);
          VAR
             Ch,ch2   : Char;
             Outf     : Text;
          LABEL
              Loop;
         BEGIN
               PrinterOn := FALSE;
               EscSw := FALSE;
               Ch := InputMenu(OutRed);
               CASE Ch OF
                    'F' : BEGIN
                               ClrScr;
                               OutputFileName(10,22,Video1,Video2,
                                              'The output file name : ',
                                              OutF,EscSw);
                               if not EscSw then
                                  OutputToFile(OutF,YrCtr)
                          END;
                    'P' : BEGIN
                               ClrScr;
                               Wait;
                               Loop:
                               Assign(OutF,'LPT1');
                               ReWrite(OutF);
                               WriteLn(Outf);
                               IF IOResult <> 0 THEN BEGIN
                                  InputErrors(1,1,7);
                                  ClearLine(22);
                                  ClearLine(23);
                                  ClearLine(24);
                                  GOTO Loop;
                               END;
                               PrinterOn := TRUE;
                               if not EscSw then
                                  OutputToFile(OutF,YrCtr)
                          END;
                    'G' : CallGraph(Years);
                    'M' : begin
                               DisplayMeanOcc(GlobInpFileName,
                                              FirstTime,Device,Mode);
                                               FirstTime := False;
                           end;
                     'S' : Begin
                                ReadSumStatsFile(MeanExtTime,
                                                 MeanDeathDist,
                                                 MeanPairDist,
                                                 MinPop,ExtinctNo,
                                                 GlobInpFileName);
                                AssignCrt(OutF);
                                ReWrite(OutF);
                                SetCursorSize(NoCursor);
                                ClrScr;
                                ProduceSummaryStats(GlobRuns,YrCtr,Pop^,
                                                    MeanExtTime,
                                                    ExtinctNo,MinPop,
                                                    MeanDeathDist,
                                                    MeanPairDist,OutF,
                                                    False);
                                CenterText(25,RevVid,'Any key to continue');
                                GetKeys(Ch,Ch2);
                                SetCursorSize(Cursor);
                          end;
                    #27 : EscSw := TRUE;
               END;
END;

PROCEDURE SetMenuColors(VAR M : Menu);
          BEGIN
               M.BackAtt  := Video1;
               M.TextAtt  := Video2;
               M.HiAtt    := HiVid;
END;

{***********************************Main Program}


BEGIN
     SetColors;
     SetMenuColors(OutRed);
     TextAttr := Video2;
     InputFileName(20,22,Video1,Video2,'The input file name : ',Inp,EscSw);
     Wait;
     New(Buff);
     SetTextBuf(Inp,Buff^,SizeOf(TextBuffer));
     IF CheckFile(Inp) THEN BEGIN
        InitializeVectors;
        GetMean(Inp,Years);
        GetStd(Inp);
        REPEAT
              ChooseOutputForm(EscSw,Years);
       UNTIL EscSw;
     END
     ELSE BEGIN
         Close(Inp);
         FatalErrors(5);
     END;
     HaltProgram;
END.

