
{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,R-,S+,V-,X-}
{$M 16384,0,655360}

USES Crt, MapBind, BindGlob, Menu123,Global, ScrLib, Owlgraph;

CONST
   MainMenu : Menu = (FirstLine  : ('Create','Look','Quit','','','','','');
                      SecondLine : ('Bind one or more maps',
                                    'Look at an existing bound map file',
                                    'Exit. Hasta la vista. Bye bye. Auf Wiedersehen.',
                                    '','','','','');
                      FstCharSet   : 'CLQ';
                      Locations    : (0,0,0,0,0,0,0,0);
                      EntryNo      : 3;
                      Position     : 1;
                      TopLineAtt   : 7;
                      BotLineAtt   : 15;
                      FstCharAtt   : 15;
                      LightBar     : 112;
                      FirstBar     : 1);
   MainMenuColors : ColorSet123 = (63,112,60,31,28);
VAR
   FirstMap : Boolean;
{Binder is a simple program that allows separate text file maps to
 be bound together into a single binary file that can be read by
 sim}
PROCEDURE InputFile(    St                : String;
                    VAR Name              : String;
                    VAR TempX,TempY       : Integer;
                    VAR EscSw             : Boolean;
                        FirstTime         : Boolean);
          VAR
             Inf         : Text;
             Flag        : Integer;
          CONST
                x : Integer = 10;
                y : Integer = 10;
          BEGIN
               InputFileName(20,22,Video2,Video1,St,Inf,EscSw);
               IF EscSw THEN Exit;
               Name := GlobInpFileName;
               ReadLn(Inf,Flag);
               EscSw := (Flag <> -9999) OR (IOResult <> 0);
               IF EscSw THEN Exit;
               IF FirstTime THEN BEGIN
                  ReadLn(Inf,x,y);
                  TempX := x;
                  TempY := y;
               END
               ELSE
                   ReadLn(Inf,TempX,TempY);
                EscSw := (TempX <> x) OR (TempY <> y) OR (IOResult <> 0);
                   IF EscSw THEN Exit;
               Close(Inf);
END;
PROCEDURE GetIntegerInput(    Lo,Hi            : Integer;
                              St               : String;
                          VAR EscSw            : Boolean;
                          VAR Output           : Integer);
          BEGIN
               ClrScr;
               SlowWrite(10,12,St);
               EscSw := InputInteger(70,12,5,Lo,Hi,Output);
END;
PROCEDURE BindFiles(VAR EscSw : Boolean);
VAR
   BindRec       : BindRecord;
   Files         : FileNameArr;
   BoundFileName,
   St            : String;
   Ct            : Word;
   Maps,Start,
   Entry,x,y     : Integer;
   OutF          : Text;
BEGIN
     Start := 2;
     WITH BindRec DO BEGIN
          OutputFileName(20,22,Video1,Video2,'The name of the bound file : ',
                          OutF,EscSw);
          IF EscSw THEN Exit;
          Close(OutF);
          Ct := IOResult;
          BoundFileName := GlobOutFileName;
          GetIntegerInput(1,100,'The number of maps to be bound : ',
                          EscSw,Maps);
          IF EscSw THEN Exit;
          MapNumber := Maps;
          FOR Ct := 1 TO MapNumber DO BEGIN
              Str(Ct:3,St);
              InputFile('Map file # ' + St + ' : ',
                         Files[Ct],x,y,EscSw,Ct=1);
              IF EscSw THEN Exit;
              IF Ct = 1 THEN BEGIN
                 EWSize := y;
                 NSSize := x;
                 Flag := -9999;
              END;
              GetIntegerInput(Start,1000,'The year to enter : ',
                          EscSw,Entry);
              IF EscSw THEN Exit;
              Start := Succ(Entry);
              EntryLog[Ct] := Entry;
          END;
     END;
     BindMaps(BindRec,Files,BoundFileName);
END;
PROCEDURE Look(VAR EscSw : Boolean);
          VAR
             Inf           : Text;
             Inf2          : File;
             BoundFile     : BindRecord;
             BoundFileName : String;
             Ct            : Word;
             Res           : Boolean;
             St            : String[4];
             Ch,Ch2        : Char;
     BEGIN
          BoundFileFirstTime := TRUE;
          YearCtr := 0;
          InputFileName(20,22,Video1,Video2,'The name of the bound file : ',
                          Inf,EscSw);
          IF EscSw THEN Exit;
          BoundFileName := GlobInpFileName;
          Close(Inf);
          Ct := IOResult;
          Assign(Inf2,BoundFileName);
          Reset(Inf2,1);
          Ct := IOResult;
          WITH BoundFile DO BEGIN
               BlockRead(Inf2,BoundFile,SizeOf(BoundFile));
               EscSw := (Flag <> BoundFlag) OR (IOResult <> 0);
               Close(Inf2);
               Ct := IOResult;
               IF EscSw THEN Exit;
               IF NOT FirstMap THEN
                  DestroyHabitatArr(Habitat);
               HabitatLength := NSSize;
               HabitatWidth := EWSize;
               ZoomXStop := EWSize;
               ZoomYStop := NSSize;
               CreateHabitatArr(Habitat);
               FirstMap := FALSE;
               FOR Ct := 1 TO MapNumber DO BEGIN
                   Res := ReadBoundStack(BoundFileName,EWSize,NSSize,
                   EntryLog[Ct],Habitat);
                   GraphicDisplay2(Ct = 1);
                   Str(EntryLog[Ct],St);
                   WriteMessage(100,'Year = '+ St + '; Any key to continue, <ESC> to quit');
                   GetKeys(Ch,Ch2);
                   IF Ch = #27 THEN BEGIN
                      RestoreTextMode;
                      Exit;
                   END;
               END;
               RestoreTextMode;
          END;
END;
PROCEDURE MainProgram;
          VAR
             Ch : Char;
             EscSw : Boolean;
          BEGIN
               SetColors;
               REPEAT
                  SetCursorSize(NoCursor);
                  CharToScreen(0,2000,'',Video1);
                  Ch := DoMenu123(MainMenu,MainMenuColors);
                  CASE Ch OF
                           'C' : BEGIN
                                      BindFiles(EscSw);
                                      IF EscSw THEN BEGIN
                                         FastWrite(3724,ErrorVid,'File not properly written');
                                         Delay(1500);
                                      END;
                                 END;
                           'L' : BEGIN
                                      Look(EscSw);
                                      IF EscSw THEN BEGIN
                                         FastWrite(3724,ErrorVid,'Problem with bound file');
                                         Delay(1500);
                                      END;
                                 END;
                      'Q',#27  : Exit;
                   END;
               UNTIL FALSE;
END;
BEGIN
    FirstMap := TRUE;
    MainProgram;
    HaltProgram;
END.
