{$R-}
UNIT Demogra;

INTERFACE

USES Global,OwlAsm,RuleSet,Dynamics,Utility, Beta, OwlGraph;

PROCEDURE KillAllAdultPairs(VAR POP : Population; Yr :Word);
PROCEDURE FledgeAllAdultPairs( VAR Pop : Population; Yr : Word);
FUNCTION KillTransient(    Loc : Word;
                       VAR Pop : Population;
                       OwlType : Byte; Yr:Word) : Boolean;
PROCEDURE IncAge(VAR Pop : Population);

IMPLEMENTATION

FUNCTION GetPairDeathProb(     Loc              : Word;
                           VAR Pop              : Population;
                               OwlType : Word ) : Single;
         VAR
            Class : Byte;
            P     : Pair;
         BEGIN
              WITH Pop DO BEGIN
                   P := PairPop^[Loc];
                   Class := GetClass(Habitat[P.Row]^[P.Column]);
                   IF OwlType = SFemale THEN begin
                          GetPairDeathProb := riskarr[p.femaleage,class];
                   end
                   ELSE  begin
                     GetPairDeathProb := riskarr[p.maleage, class];

                   end;
         end;
end;

PROCEDURE KillAllAdultPairs(VAR POP : Population; Yr:Word);
          VAR
             MaleDeath,FemaleDeath : Boolean;
             Ct                    : Integer;
          BEGIN
               WITH Pop DO BEGIN
                    Ct := Succ(PairCtr);
                    WHILE Ct > 1 DO BEGIN
                        Dec(Ct);
                        MaleDeath   := (Rand <= GetPairDeathProb(Ct,Pop,
                                                            SMale));
                        FemaleDeath := (Rand <= GetPairDeathProb(Ct,Pop,
                                                            SFemale));
                        IF (MaleDeath AND FemaleDeath) THEN BEGIN
                           KillOwlOrPair(PairPop^[Ct].Column,
                                         PairPop^[Ct].Row,
                                         Ct,Pop,OwlPair);
                       
                        END
                         ELSE BEGIN
                              IF MaleDeath THEN
                                 PairToFemale(PairPop^[Ct].Column,
                                              PairPop^[Ct].Row,
                                              Pop,Ct)
                              ELSE IF FemaleDeath THEN
                                   PairToMale(PairPop^[Ct].Column,
                                                     PairPop^[Ct].Row,
                                                    Pop,Ct);
                       END;
                    END;
               END;
END;

PROCEDURE FledgeAllAdultPairs(VAR Pop : Population; Yr : Word);

          VAR
             FledgeProb             : Extended;
             Ct, PairType, PairAge,
             Males,Females,
             OwlCtr, X, Y            : Word;
          BEGIN
               fledgetotal := 0;
               WITH Pop DO BEGIN
                    FOR Ct := 1 TO PairCtr DO BEGIN

                     IF (PairPop^[ct].MaleAge<PairPop^[ct].FemaleAge) THEN
                           PairAge := PairPop^[ct].MaleAge
                        ELSE
                           PairAge := PairPop^[ct].FemaleAge;
                        X := PairPop^[ct].Column;
                        Y := PairPop^[ct].Row;
                        Males   := 0;
                        Females := 0;
                        FledgeProb := Fledgearr[pairage, GetClass(Habitat[PairPop^[ct].Row]^[Pairpop^[ct].Column])];
                        IF (rand <= FledgeProb) THEN BEGIN
                           Inc(FledgeTotal,FledgeNo);
                           FOR OwlCtr := 1 TO FledgeNo DO BEGIN
                              IF rand <= MaleFledgeProb THEN
                                Inc(Males)
                              ELSE
                                Inc(Females);
                           END;
                        END;
                        Fledge(PairPop^[Ct].Column,
                               PairPop^[Ct].Row,Males,Females,Ct,OwlPair, Pop);
                    END;
               END;

END;

Function DeadJuvenile(Age : Word;Class: Byte): Boolean;


          BEGIN

                DeadJuvenile  := (rand <= riskArr[age,class]);
end;


FUNCTION KillTransient(    Loc : Word;
                       VAR Pop : Population;
                       OwlType : Byte;Yr:Word) : Boolean;
VAR
   x,y    : Word;
   Holder : Boolean;
   OwlHolder : Byte;
   M        : SingleMale;
   F        : SingleFemale;
   class : byte;
BEGIN
     OwlHolder := OwlType;
     Holder    := FALSE;
     WITH Pop DO BEGIN
          CASE OwlType OF
               SMale : BEGIN
                          FastMove(MalePop^[Loc],M,SizeOf(SingleMale));
                          X := M.Column;
                          Y := M.Row;
                          class := getClass(Habitat[y]^[x]);
                          IF DeadJuvenile(M.Age, class)
                             THEN BEGIN
                               IF M.Settled THEN
                                  OwlHolder := SettledMale;
                             KillOwlOrPair(X,Y,Loc,Pop,OwlHolder);
                             Holder := TRUE;
                          END;
                       END;
             SFemale : BEGIN
                          FastMove(FemalePop^[Loc],F,SizeOf(SingleFemale));
                          X := F.Column;
                          Y := F.Row;
                          class := getClass(Habitat[y]^[x]);
                          IF DeadJuvenile(F.Age, class)  THEN BEGIN
                                KillOwlOrPair(X,Y,Loc,Pop,SFemale);
                                Holder := TRUE;
                             END;
                       END;
          END;
     END;
     KillTransient := Holder;
END;

PROCEDURE IncAge(VAR Pop : Population);
VAR
  Ct : Word;
  X, Y : Word;
  Age, owl : Byte;
BEGIN
   With Pop DO BEGIN
      For Ct := 1 To MaleCtr DO 
         IF (MalePop^[Ct].Age < maxstage) Then BEGIN
            Inc(MalePop^[Ct].Age);
            IF GraphOn THEN BEGIN
               X := MalePop^[Ct].Column;
               Y := MalePop^[Ct].Row;
               IF Not IsMultiple(Habitat[Y]^[X]) THEN
                  GraphicChangeBird(X,Y)
               ELSE BEGIN
                  Owl := SearchForOwls(X,Y,Pop,Smale,Age);
                  IF (Owl = Smale) OR (Owl = SettledMale) THEN
                          GraphicChangeBird(X,Y);
               END;
            END;
         END;
      For Ct := 1 To FemaleCtr DO
         IF (FemalePop^[Ct].Age < maxstage) Then BEGIN
            Inc(FemalePop^[Ct].Age);
            IF GraphOn THEN BEGIN
               X := FemalePop^[Ct].Column;
               Y := FemalePop^[Ct].Row;
               IF NOT IsMultiple(Habitat[Y]^[X]) THEN
                  GraphicChangeBird(X,Y)
               ELSE BEGIN
                  Owl := SearchForOwls(X,Y,Pop,SFemale,Age);
                  IF (Owl = SFemale) THEN
                          GraphicChangeBird(X,Y);
               END;
            END;
         END;
      For Ct := 1 TO PairCtr DO
         With PairPop^[Ct] DO BEGIN
            IF (MaleAge < maxstage) THEN
              Inc(MaleAge);
            IF (FemaleAge < maxstage) THEN
               Inc(FemaleAge);
            IF FemaleAge <= MaleAge
               THEN Age := FemaleAge
            ELSE Age := MaleAge;
            if GraphOn then begin
               X := PairPop^[Ct].Column;
               Y := PairPop^[Ct].Row;
               GraphicChangeBird(X,Y);
            end;
         END;
   END;
END;
BEGIN
END.