{$A+,B-,D+,E-,F-,I-,L+,N+,O-,R-,S-,V-}
{$M 16384,0,655360}

UNIT IncBeta2;
INTERFACE
USES Crt,Math,Graph;
CONST
  Xorig1 : INTEGER = 100;
  Yorig  : INTEGER = 350;
  Xlen   : INTEGER = 400;
  Ylen   : INTEGER = 200;
  FunctN = 50;
  BackColor : Byte = 0;
TYPE
    DoubArr  = Array[0..FunctN] OF Double;
    WordArr  = Array[0..FunctN] OF Word;
VAR
  Landscape,Err                            : BOOLEAN;
  St1,St2                                  : STRING;
  Ans1,Ans2                                : CHAR;
  Xscale,Yscale,Ymax                       : Double;
  Mu,Sigma,a,b,x                           : DOUBLE;
  Xdec,Y1dec,Y2dec                         : DoubArr;
  XArr,YArr                                : WordArr;
  Gd,Gm,Cnt,
  Xplot,Yplot,Xpos,Ypos,Plotnum            : INTEGER;
  OldSigma,OldMu                           : Double;
  Error                                    : Boolean;

PROCEDURE ComputeAB(Mu,Sigma : Double;VAR a,b : Double);
PROCEDURE GetBetaVal(    N                   : Word;
                         a,b                 : Double;
                     VAR Xdec,Y1dec,Y2dec    : DoubArr;
                     VAR YMax                : Double;
                     VAR Error               : Boolean);
PROCEDURE InitGraphics(VAR Gd,Gm : Integer; Spike : Boolean;mu :double);
PROCEDURE Closegraphics;
PROCEDURE GetPlots(VAR XPlot,YPlot : WordArr);
PROCEDURE DrawPlots(VAR XPlot,YPlot : WordArr;Color : Byte);
IMPLEMENTATION

  LABEL
       RepeatDueToError;

FUNCTION betacf(a,b,x: double): double;
LABEL 1;
CONST
   itmax=100;
   eps=3.0e-16;
  
VAR
   tem,qap,qam,qab,em,d,
   bz,bpp,bp,bm,az,app,
   am,aold,ap            : double;
   m                     : word;
BEGIN
   qab := a+b;
   qap := a+1.0;
   qam := a-1.0;
   bz := 1.0-qab*x/qap;
   d := (b-1)*x/((qam+2)*(a+2));
   ap := 1.0+d;
   bp := bz+d;
   d := -(a+1.0)*(qab+1.0)*x/((a+2)*(qap+2));
   app := ap+d;
   bpp := 1/(bp+d*bz);
   am := ap*bpp;
   bm := bp*bpp;
   az := app*bpp;
   IF ((abs(az-1.0)) < (eps*abs(az))) THEN GOTO 1;
   FOR m := 2 to itmax DO BEGIN
      em := m;
      tem := em+em;
      d := em*(b-em)*x/((qam+tem)*(a+tem));
      ap := az+d*am;
     bp := 1+d*bm;
      d := -(a+em)*(qab+em)*x/((a+tem)*(qap+tem));
      app := ap+d*az;
      bpp := 1.0/(bp+d);
      aold := az;
      am := ap*bpp;
      bm := bp*bpp;
      az := app*bpp;
      IF ((abs(az-aold)) < (eps*abs(az))) THEN GOTO 1
   END;
1:   betacf := az;
END;

PROCEDURE Betai(VAR a,b,x,ibeta,fx: double);
  CONST
      MinLn = -11350;
  VAR
    bt,compx,gamratio,errchk   : double;
  BEGIN
    gamratio := LnGammaFn(a+b)-LnGammaFn(a)-LnGammaFn(b);
    IF ((x = 0.0) OR (x = 1.0)) THEN BEGIN
      bt := 0.0;
      fx := 0.0; END
    ELSE BEGIN
      errchk := gamratio+a*Ln(x)+b*Ln(1.0-x);
      IF (errchk < MinLn) THEN bt := 0
      ELSE
         bt := Exp(errchk);
      errchk := gamratio+(a-1)*Ln(x)+(b-1)*Ln(1-x);
      IF (errchk < MinLn) THEN fx := 0
      ELSE
         fx := Exp(errchk);
    END;
    IF (x < ((a+1.0)/(a+b+2.0))) THEN
      ibeta := bt*Betacf(a,b,x)/a
    ELSE BEGIN
      compx := 1-x;
      ibeta := 1.0-bt*Betacf(b,a,compx)/b;
    END;
  END;

PROCEDURE ComputeAB(Mu,Sigma : Double;VAR a,b : Double);
          VAR
             MuVal : Double;
          BEGIN
               Muval := (1-Mu)/Mu;
               a := (Muval/(Sqr(Sigma*(1+Muval)))-1)/(1+Muval);
               b := a*Muval;
END;
PROCEDURE DrawAxes(Xorig,Yorig,Xlen,Ylen : Word;
                   VAR Xscale,Yscale : Double; spike : boolean; mu: double);
  CONST
    Ticklenpct = 2.5;
    Tickgappct = 10;
  VAR
    St                                    : STRING[3];
    Axislabel                             : STRING[30];
    Ct,Tick,Delxtick,Delytick,
    Xpos,Xleft1,Xleft2,
    Ypos,Ydown1,Ydown2                    : INTEGER;
    Maxscale                              : Single;

  BEGIN
    SetTextJustify(CenterText,CenterText);
    Xscale := Xlen/100.0;
    Yscale := Ylen/100.0;
    IF Xscale >= Yscale THEN Maxscale := Xscale ELSE Maxscale := Yscale;
    Tick := Trunc(Ticklenpct*Maxscale);
    Delxtick := Trunc(Tickgappct*Xscale);
    Delytick := Trunc(Tickgappct*Yscale);
    Line(Xorig,Yorig,Xorig,Yorig-Ylen);
    Xleft1 := Xorig-Tick;

    FOR Ct := 0 TO 10 DO BEGIN
      Ypos := Yorig-Ct*Delytick;
      Line(Xleft1,Ypos,Xorig,Ypos);
      IF Plotnum = 2 THEN BEGIN
        Xleft2 := Xorig-4*Tick;
        IF (Ct = 0) OR (Ct = 5) OR (Ct = 10) THEN BEGIN
          Str(Ct/10.0:3:1,St);
          OutTextXY(Xleft2,Ypos,St);
        END;
      END;
    END;
    Line(Xorig,Yorig,Xorig+Xlen,Yorig);
    Ydown1 := Yorig+Tick;
    Ydown2 := Yorig+3*Tick;
    FOR Ct := 0 TO 10 DO BEGIN
      Xpos := Xorig+Ct*Delxtick;
      Line(Xpos,Yorig,Xpos,Ydown1);
      IF (Ct = 0) OR (Ct = 5) OR (Ct = 10) THEN BEGIN
        Str(Ct/10.0:3:1,St);
        OutTextXY(Xpos,Ydown2,St);
      END;
    END;
    Xpos := Xorig+Xlen DIV 2;
    Ypos := Yorig+6*Tick;
    OutTextXY(Xpos,Ypos,'X');
    Ypos := Yorig-Ylen DIV 2;
    SetTextStyle(DefaultFont,VertDir,1);
    IF Plotnum = 1 THEN BEGIN
      Xpos := Xorig-6*Tick;
      Axislabel := 'f(x) (relative scale)'; END
    ELSE BEGIN
      Xpos := Xorig-10*Tick;
      Axislabel := 'Incomplete beta function';
    END;
    OutTextXY(Xpos,Ypos,Axislabel);
    SetTextStyle(DefaultFont,Horizdir,1);
    IF Spike THEN BEGIN
       SetColor(LightGreen);
       XPos := Xorig + Trunc(Xscale * mu*100);
       Line(XPos, YOrig,XPos, Yorig - Trunc(Yscale*100));
    END;
END;
PROCEDURE GetPlots(VAR XPlot,YPlot : WordArr);
          VAR
             i : Word;
          BEGIN
               FOR i := 0 TO FunctN DO BEGIN
                   Xplot[i] := Trunc(Xdec[i]*Xscale*100)+1;
                   Yplot[i] := Trunc(Y1dec[i]*Yscale*100/Ymax)+1;
               END;
END;
PROCEDURE DrawPlots(VAR XPlot,YPlot : WordArr;Color : Byte);
          VAR
             i : Word;
          BEGIN
               SetColor(Color);
                  MoveTo(Xorig1+Xplot[0],Yorig-Yplot[0]);
                  FOR i := 1 TO FunctN DO BEGIN
                      LineTo(Xorig1+Xplot[i],Yorig-Yplot[i]);
                  END;
END;
PROCEDURE ChangeSigmaMU(Ch : Char;VAR Sigma,Mu : Double);
          BEGIN
               IF Ch = #0 THEN BEGIN
                  OldSigma := Sigma;
                  OldMu    := Mu;
                  CASE ReadKey OF
                       #72 :  Sigma := Sigma + 0.01;
                       #80 :  Sigma := Sigma - 0.01;
                       #77 :  Mu    := Mu + 0.01;
                       #75 :  Mu    := Mu - 0.01;
                  END;
               END;
END;
PROCEDURE OutputSigmaMu(Sigma,Mu : Double);
          VAR
             St : String[6];
          BEGIN
               SetFillStyle(1,BackColor);
               SetColor(LightRed);
               Str(Mu:7:2,St);
               SetTextJustify(1,1);
               Bar(GetMaxX SHR 1,GetMaxY - 34,GetMaxX SHR 1 + 60,GetMaxY - 16);
               OutTextXY(GetMaxX SHR 1,GetMaxY-30,'Mu    = '+St);
               Str(Sigma:7:2,St);
               OutTextXY(GetMaxX SHR 1,GetMaxY-20,'Sigma = '+St);
               SetTextJustify(0,2);
               SetColor(White);
END;
PROCEDURE GetBetaVal(    N                   : Word;
                         a,b                 : Double;
                     VAR Xdec,Y1dec,Y2dec    : DoubArr;
                     VAR YMax                : Double;
                     VAR Error               : Boolean);
          VAR
             i          : Word;
             Fraction   : Double;
          BEGIN
               Ymax := 0;
               Fraction := 1/N;
               Error := FALSE;
               FOR i := 0 TO N DO BEGIN
                   Xdec[i] := i * Fraction;
                   Betai(a,b,Xdec[i],Y2dec[i],Y1dec[i]);
                   IF ThereAreExceptions THEN BEGIN
                      Error := TRUE;
                      Exit;
                   END;
                   IF Y1dec[i] > Ymax THEN
                      Ymax := Y1dec[i];   {scaled to Ymax}
               END;
END;
PROCEDURE InitGraphics(VAR Gd,Gm : Integer; Spike : Boolean;mu : Double);
          BEGIN
               IF Gd = 0 THEN BEGIN
                  InitGraph(Gd,Gm,'');
                  IF GraphResult <> 0 THEN BEGIN
                     WriteLn('BGI driver not found');
                     Halt;
                  END;
               END;
               IF Gd IN [3,9] THEN
                   SetBkColor(Blue)
               else
                   SetBkColor(BackColor);
               Plotnum := 1;
               DrawAxes(Xorig1,Yorig,GetMaxX-200,GetMaxY-300,Xscale,Yscale,
                   Spike,mu);

END;
PROCEDURE Closegraphics;
BEGIN
  CLoseGraph;
END;
BEGIN
{     MaskExceptions;
     Mu    := 0.5;
     Sigma := 0.2;
     x     := 1;
     Gd := 0;
     Gm := 0;
     InitGraphics(Gd,Gm);
     REPEAT
           RepeatDueToError:
           ComputeAB(Mu,Sigma,a,b);
           GetBetaVal(FunctN,a,b,Xdec,Y1dec,Y2dec,YMax,Error);
           IF Error THEN BEGIN
              Sigma := OldSigma;
              Mu    := OldMu;
              GOTO RepeatDueToError;
           END;
           GetPlots(XArr,YArr);
           DrawPlots(XArr,YArr,LightGreen);
           OutputSigmaMu(Sigma,Mu);
           Ans1 := Upcase(Readkey);
           DrawPlots(XArr,YArr,BackColor);
           ChangeSigmaMu(Ans1,Sigma,Mu);
     UNTIL Ans1 = #27;
     CloseGraph;}
END.
