UNIT LaserPr;

INTERFACE

USES Printer,Graph,Crt;

PROCEDURE LaserPrintScreen(Device : Word;VAR Err : Boolean);
PROCEDURE LaserLandscapePrintScreen(Device : Word;VAR Err : Boolean);

IMPLEMENTATION

TYPE
    CharArr = Array[1..100] OF Char;
PROCEDURE WriteLine(CharNo : Word;x : CharArr;VAR Err : Boolean);
          VAR
             Ct : Word;
          BEGIN
               Write(Lst,#27'*b',CharNo,'W');
               FOR Ct := 1 TO CharNo DO
                   Write(Lst,x[Ct]);
               Err := IOResult <> 0;
END;
PROCEDURE SetPrintGraphics(Device : Word;VAR Error : Boolean);
          BEGIN
               Write(Lst,#27'*t100R'#27'*r0A');
               Error := IOResult <> 0;

END;
PROCEDURE KillPrintGraphics(VAR Error : Boolean);
          BEGIN
               Write(Lst,#27'*rB');
               Write(Lst,#12);
               Error := IOResult <> 0;
END;
PROCEDURE LaserPrintScreen(Device : Word;VAR Err : Boolean);
          VAR
             Rows,Columns     : Word;
             Ct1,Ct2,Element,
             LineWidth        : Word;
             BitCtr,OutBit    : Byte;
             Pixel            : Word;
             Arr              : CharArr;
             Ch               : Char;
          BEGIN
               FillChar(Arr,SizeOf(Arr),0);
               SetPrintGraphics(Device,Err);
               IF Err THEN Exit;
               Rows := GetMaxY;
               Columns := GetMaxX;
               LineWidth := Succ(Columns SHR 3); {div 8}
               FOR Ct1 := 0 TO Rows DO BEGIN
                   BitCtr := 8;
                   Element := 0;
                   Outbit := 0;
                   FOR Ct2 := 0 TO Columns DO BEGIN
                       Dec(BitCtr);
                       IF BitCtr > 7 THEN BEGIN
                          BitCtr := 7;
                          Inc(Element);
                          Arr[Element] := Char(OutBit);
                          Outbit := 0;
                       END;
                       Pixel := GetPixel(Ct2,Ct1);
                       IF Pixel <> 0 THEN BEGIN
                          if (Pixel = 2) then begin
                             if (Random(2) = 1) then
                                 OutBit := OutBit OR (1 SHL BitCtr);
                          end
                          else
                              OutBit := OutBit OR (1 SHL BitCtr);
                       END;
                   END;
                   Arr[Element] := Char(OutBit);
                   WriteLine(LineWidth,Arr,Err);
                   IF Err THEN Exit;
                   IF Keypressed THEN BEGIN
                      Ch := ReadKey;
                      IF Ch = #27 THEN BEGIN
                         KillPrintGraphics(Err);
                         Exit;
                      END
                      ELSE IF Ch = #0 THEN
                           Ch := ReadKey;
                   END;
               END;
               KillPrintGraphics(Err);
END;
Procedure LandscapeSetPrintGraphics(device : word;VAR Error : Boolean);
          begin
               write(lst,#27'*t150R'#27'*r0A');
               Error := IOResult <> 0;
end;
Procedure doubleBits(x : byte;VAR y : Word);
          var
             ct,ctr,sh : byte;
          begin
               Ctr := 0;
               y   := 0;
               for ct := 0 to 7 do begin
                   sh := 1 shl ct;
                   if x and sh <> 0 then begin
                      y := y or (1 shl ctr);
                      y := y or (1 shl Succ(ctr));
                   end;
                   inc(ctr,2);
               end;
end;
Procedure LandscapeWriteLine(CharNo : Word;x : CharArr;VAR Err : Boolean);
          var
             Ct,Ct2 : Word;
             db : word;
          begin
               for Ct2 := 1 to 2 do begin
                  write(Lst,#27'*b',CharNo*2,'W');
                  for ct := 1 to CharNo do begin
                      DoubleBits(Byte(x[Ct]),db);
                      Write(lst,Char(hi(db)),char(lo(db)));
                   end;
               end;
               Err := IOResult <> 0
end;
PROCEDURE LaserLandscapePrintScreen(Device : Word;VAR Err : Boolean);
          VAR
             Rows,Columns     : Word;
             Ct1,Ct2,Element,
             LineWidth        : Word;
             BitCtr,OutBit    : Byte;
             Pixel            : Word;
             Arr              : CharArr;
             Ch               : Char;
          BEGIN
               FillChar(Arr,SizeOf(Arr),0);
               LandscapeSetPrintGraphics(Device,Err);
               IF Err THEN Exit;
               Rows := GetMaxY;
               Columns := GetMaxX;
               LineWidth := Succ(Rows shr 3); {div 8}
               FOR Ct1 := Columns downtO 0 DO BEGIN
                   BitCtr := 8;
                   Element := 0;
                   outbit := 0;
                   FOR Ct2 := 0 TO Rows DO BEGIN
                       dec(bitCtr);
                       if BitCtr > 7 then begin
                          BitCtr := 7;
                          inc(Element);
                          Arr[element] := Char(OutBit);
                          outbit := 0;
                       end;
                       Pixel := GetPixel(Ct1,Ct2);
                       IF Pixel <> 0 THEN BEGIN
                          OutBit := OutBit OR (1 SHL BitCtr);
                       END;
                   END;
                   Inc(Element);
                   Arr[element] := Char(OutBit);
                   LandscapeWriteLine(LineWidth,Arr,Err);
                   IF Err THEN Exit;
                   IF Keypressed THEN BEGIN
                      Ch := ReadKey;
                      IF Ch = #27 THEN BEGIN
                         KillPrintGraphics(Err);
                         Exit;
                      END
                      ELSE IF Ch = #0 THEN
                           Ch := ReadKey;
                   END;
               END;
               KillPrintGraphics(Err);
END;
BEGIN
END.