UNIT MeanOcc;

INTERFACE

USES Global,OwlAsm,Utility,Owlgraph,Graph;

{this program tracks mean occupancy of nesting pairs over time}
TYPE
    OccupancyFile = File OF Word;  {first word is a year ctr, then x,y,}
                                   {then simply a sequential array}



PROCEDURE InitializeFile(    X,Y      : Word;
                         VAR OccFile  : OccupancyFile;
                             FileName : String);
PROCEDURE UpdateOccupancy(X,Y : Word;VAR OccFile : OccupancyFile);
PROCEDURE DisplayMeanOcc(FileName : String;FirstTime : Boolean;
                         Device,Mode : Integer);

IMPLEMENTATION

{suffix must have a .}
FUNCTION NewFileName(FileName : String;Suffix : String):String;
         VAR
            DotPos : Byte;
         BEGIN
              DotPos := LastCharPos('.',FileName);
               IF DotPos <> 0 THEN
                  FileName := Copy(FileName,1,Pred(DotPos));
               FileName := FileName + Suffix;
               NewFileName := FileName;
END;
PROCEDURE InitializeFile(    X,Y      : Word;
                         VAR OccFile  : OccupancyFile;
                             FileName : String);
          VAR
             Ct1,Ct2,Temp : Word;
          BEGIN
               Assign(OccFile,NewFileName(FileName,'.MOX'));
               ReWrite(OccFile);
               IF IOResult <> 0 THEN
                  FatalErrors(5);
               Temp := 0;
               Write(OccFile,Temp);
               Write(OccFile,X);
               Write(OccFile,Y);
               FOR Ct1 := 1 TO Y DO
                   FOR Ct2 := 1 TO X DO
                       Write(OccFile,Temp);
END;
PROCEDURE UpdateOccupancy(X,Y : Word;VAR OccFile : OccupancyFile);
          VAR
             Ct1,Ct2,Temp,Ctr : Word;
             FilePosition     : LongInt;
          BEGIN
               Seek(OccFile,0);
               Read(OccFile,Temp);
               Seek(OccFile,0);
               Inc(Temp);
               Write(OccFile,Temp);
               Ctr := 3;
               FOR Ct1 := 1 TO Y DO BEGIN        {Get the map}
                   FOR Ct2 := 1 TO X DO BEGIN
                       Temp := GetOwl(Habitat[Ct1]^[Ct2]);
                       IF (Temp = 3) THEN BEGIN
                          Seek(OccFile,Ctr);
                          Read(OccFile,Temp);
                          Inc(Temp);
                          Seek(OccFile,Ctr);
                          Write(OccFile,Temp);
                       END;
                       Inc(Ctr);
                   END;
               END;
END;

{in the map, occupancy is a number from 0 to 10 that fills the owl
 slot}

PROCEDURE CreateMap(FileName : String);
          VAR
             OccFile   : OccupancyFile;
             Ct1,Ct2,Years,
             X,Y,Temp      : Word;
             MeanOcc       : Byte;
          BEGIN
               Assign(OccFile,NewFileName(FileName,'.MOX'));
               ReSet(OccFile);
               IF IOResult <> 0 THEN
                  FatalErrors(5);
               Read(OccFile,Years);
               Read(OccFile,X);
               Read(OccFile,Y);
               HabitatWidth := X;
               HabitatLength := Y;
               ZoomXStop := X;
               ZoomYStop := Y;
               CreateHabitatArr(Habitat);
               FOR Ct1 := 1 TO Y DO BEGIN
                   FOR Ct2 := 1 TO X DO BEGIN
                       Read(OccFile,Temp);
                       AddOwl(Trunc(9.9999 * (Temp/Years)) + 1,Habitat[Ct1]^[Ct2]);
                   END;
               END;
               Close(OccFile);
END;
PROCEDURE DisplayMeanOcc(FileName : String;FirstTime : Boolean;
                         Device,Mode : Integer);
          VAR
             EscSw : Boolean;
          BEGIN
               EscSw := FALSE;
               IF Firsttime THEN
                  CreateMap(FileName);
               MoGraphicDisplay(Device = 0,Device,Mode);
               WHILE NOT EscSw DO
                     MOInterceptKeys(EscSw);
               RestoreTextMode;
END;
BEGIN
END.



