UNIT Menus;

INTERFACE

USES ScrLib,Crt,Dos,OwlAsm,Global, OwlGraph,RuleSet, MapBind, BindGlob;

TYPE
    CharSet = Set OF Char;
    Menu = RECORD
                 StartX,StartY         : Byte;
                 BackAtt,TextAtt,HiAtt,
                 N                     : Byte;
                 PosArr                : Array[1..5] OF Byte;
                 StrArr                : Array[1..5] OF String[39];
                 LetterSet             : CharSet;
           END;
CONST
ChangePar  : Menu = (StartX   : 33;
                     StartY   : 11;
                     BackAtt  : 7;
                     TextAtt  : 7;
                     HiAtt    : 15;
                     N        : 3;
                     PosArr   : (1,1,1,1,1);
                     StrArr   : ('Change Parameters',
                                 'View Parameters',
                                 'Simulate','','');
                     LetterSet : ['C','V','S',#27]);
 DispGraph : Menu = (StartX   : 32;
                     StartY   : 11;
                     BackAtt  : 7;
                     TextAtt  : 7;
                     HiAtt    : 15;
                     N        : 2;
                     PosArr   : (1,1,1,1,1);
                     StrArr   : ('Display model output',
                                 'Quit',
                                 '','','');
                     LetterSet : ['D','Q',#27]);
   DispOut : Menu = (StartX   : 32;
                     StartY   : 11;
                     BackAtt  : 7;
                     TextAtt  : 7;
                     HiAtt    : 15;
                     N        : 2;
                     PosArr   : (1,1,1,1,1);
                     StrArr   : ('Display model output',
                                 'Quit','','','');
                     LetterSet : ['D','Q',#27]);

    OutRed : Menu = (StartX   : 33;
                     StartY   : 11;
                     BackAtt  : 7;
                     TextAtt  : 7;
                     HiAtt    : 15;
                     N        : 3;
                     PosArr   : (11,11,11,1,1);
                     StrArr   : ('output to File',
                                 'output to Printer',
                                 'output to Screen','','');
                     LetterSet : ['F','P','S',#27]);
  ScreenCh : Menu = (StartX   : 33;
                     StartY   : 11;
                     BackAtt  : 7;
                     TextAtt  : 7;
                     HiAtt    : 15;
                     N        : 2;
                     PosArr   : (1,1,1,1,1);
                     StrArr   : ('Graphics',
                                 'Summary statistics',
                                 '','','');
                     LetterSet : ['G','S',#27]);
 EmptyMenu : Menu = (StartX   : 33;
                     StartY   : 11;
                     BackAtt  : 7;
                     TextAtt  : 7;
                     HiAtt    : 15;
                     N        : 0;
                     PosArr   : (1,1,1,1,1);
                     StrArr   : ('',
                                 '',
                                 '','','');
                     LetterSet : [#1..#255]);


FUNCTION InputMenu(VAR M : Menu) : Char;
PROCEDURE RetrieveFile(HiColor    : Byte;
                       FlagNo     : Integer;
                       FirstTime  : Boolean;
                   VAR EscSw      : Boolean);
FUNCTION ChooseGraphics : Boolean;
FUNCTION ChooseDynamicMaps(VAR St : String): Boolean;
PROCEDURE SetMenuColors(VAR M : Menu);
PROCEDURE YearPop(RunCtr,YrCtr : Word);
PROCEDURE PickUpRules;
PROCEDURE SimSetColors;

IMPLEMENTATION

FUNCTION ReturnLetter(Chrs : CharSet) : Char;
         VAR
            Ch,Ch2 : Char;
         BEGIN
              REPEAT
                    GetKeys(Ch,Ch2);
                    Ch := Upcase(Ch);
              UNTIL Ch IN Chrs;
              ReturnLetter := Ch;
END;
FUNCTION InputMenu(VAR M : Menu) : Char;
          VAR
             Posit               : Word;
             Ct,SaveAtt,TempY    : Byte;
          BEGIN
               SetCursorSize(NoCursor);
               WITH M DO BEGIN
                    TempY := StartY;
                    SaveAtt  := TextAttr;
                    TextAttr := BackAtt;
                    ClrScr;
                    Posit := GetScrPos(StartX,StartY);
                    FOR Ct := 1 TO N DO BEGIN
                        HighLightWrite(StartX,TempY,PosArr[Ct],TextAtt,
                                       HiAtt,StrArr[Ct]);
                        Inc(TempY);
                    END;
                    CenterText(24,BackAtt,'Hit <ESC> to exit program');
                    InputMenu := ReturnLetter(LetterSet);
               END;
              TextAttr := SaveAtt;
               SetCursorSize(Cursor);

END;
PROCEDURE RetrieveFile(HiColor    : Byte;
                       FlagNo     : Integer;
                       FirstTime  : Boolean;
                   VAR EscSw      : Boolean);
          VAR
             Ct1,Ct2,
             Posit    : Word;
             Flag     : Integer;
             S        : SearchRec;
             filename : String;
            inf      : text;
             X        : Byte;
          LABEL
               LOOP;
          BEGIN
               LOOP:
                InputFileName(10,22,TextAttr,HiColor,'The map file : ',Inf,EscSw);
                IF EscSw THEN
                   Exit;
                ReadLn(Inf,Flag);
                IF Flag <> FlagNo THEN BEGIN
                   InputErrors(1,1,6);
                   GOTO LOOP;
                END;
                Readln(Inf,HabitatLength,HabitatWidth);
                ZoomXStop  := HabitatWidth;
                ZoomYStop  := HabitatLength;
                IF FirstTime THEN
                   CreateHabitatArr(Habitat);
                FOR Ct1 := 1 TO HabitatLength DO
                    FOR Ct2 := 1 TO HabitatWidth DO BEGIN
                        Read(Inf,X);
                        IF FlagNo = OwlFlag THEN
                           AddOwl(X,Habitat[Ct1]^[Ct2])
                        ELSE
                            Habitat[Ct1]^[Ct2] := X;
                    END;
                Close(Inf);
END;
FUNCTION ChooseGraphics : Boolean;
          VAR
             Ch : Char;
          BEGIN
               ClrScr;
               SlowWrite(30,12,'Display Graphics? (Y,N) : ');
               Ch := ReturnYesNo;
               GraphOn := (Ch = 'Y');
               ChooseGraphics := GraphOn;
               ClrScr;
               IF Ch = 'Y' THEN BEGIN
                  GraphicDisplay2(TRUE);
                  WriteMessage(100,
                         'Any key to halt, <F1> to zoom, <ESC> to quit');
               END;
END;
FUNCTION ChooseDynamicMaps(VAR St : String): Boolean;
          VAR
              Ct : Integer;
             Ch    : Char;
             Inf   : Text;
             EscSw : Boolean;
          BEGIN
            REPEAT
               ClrScr;
               SlowWrite(30,12,'Dynamic maps? (Y,N) : ');
               Ch := ReturnYesNo;
               IF Ch = 'N' THEN
                  EscSw := FALSE;
               if Ch = 'Y' then begin
                  InputFileName(20,22,Video2,Video1,'The bound map file : ',
                  Inf,EscSw);
                  if EscSw then
                     HaltProgram;
                  St := GlobInpFileName;
                  Close(Inf);
                  With BoundMap do begin
                     Assign(OutP,St);
                     Reset(OutP,1);
                     Ct := IOResult;
                     IF (IOResult <> 0) THEN BEGIN
                        InputErrors(1,1,3);
                        EscSw := TRUE;
                     END
                     ELSE BEGIN
                          BlockRead(OutP,BoundMap,SizeOf(BoundMap));
                          if Flag <> BoundFlag then BEGIN
                          InputErrors(1,1,6);
                          EscSw := TRUE;
                     END;
                     if (EWSize <> HabitatWidth) or (NSSize <> HabitatLength) then BEGIN
                         InputErrors(1,1,4);
                         EscSw := TRUE;
                     END;
                  END;
               end;
            END;
               ChooseDynamicmaps := (Ch = 'Y') AND NOT EscSw;
            UNTIL NOT EscSw;

END;


PROCEDURE ReadRealArr(VAR Inf : Text;VAR Arr : RealCriteria);
          VAR
              Ct : Word;
          BEGIN
               FOR Ct := 1 TO 8 DO
                   Read(Inf,Arr[Ct]);
END;

PROCEDURE ReadIntArr(VAR Inf : Text;VAR Arr : AcceptCriteria);
          VAR
              Ct : Word;
          BEGIN
               FOR Ct := 1 TO 8 DO
                   Read(Inf,Arr[Ct]);
END;

PROCEDURE PickUpRules;
          VAR
         
             EscSw : Boolean;
             Flag  : Integer;
             Ct    : Word;
             inf : Text;

          BEGIN
              InputFileName(20,22,Video2,Video1,'The Rules File : ',Inf,EscSw);
               IF EscSw THEN
                  HaltProgram;
               ReadLn(Inf,Flag);
               {IF Flag <> -6666 THEN
                  FatalErrors(7);}
               Readln(Inf, stages);
               MaxStage := Stages - 1;
               For ct := 0 To (maxstage) DO
                  ReadRealArr(Inf, SurvivalMean[ct]);
               For ct := 0 To (maxstage) DO
                  ReadRealArr(Inf, SurvivalVar[ct]);
               FOR ct := 0 To (maxstage) DO
                  ReadRealArr(Inf,FledgeMean[ct]);                
               FOR ct := 0 To (maxstage) DO
                  ReadRealArr(Inf,FledgeVar[ct]);
               Read(Inf, FLedgeNo);
               Read(Inf,MaleFledgeProb);
               ReadIntArr(Inf,LandClassOK);
               ReadRealArr(Inf,Aversion);
               Read(Inf,FemSearchProb);
               Read(Inf,PairAversion);
               Read(Inf,DirectionalWeight);
               ReadRealArr(Inf,WanderLust);
               Read(Inf,BoundaryCondition);
               Read(Inf,Runs);
               Read(Inf,Years);
               Read(Inf,DeltaT);
               CumFledgeProb := 0.0;
          IF IOResult <> 0 THEN
             FatalErrors(7);
          close(inf);
END;

PROCEDURE YearPop(RunCtr,YrCtr : Word);
          BEGIN
               ClearLine(10);
               GoToXY(1,10);
               Write('Run = ',RunCtr:3);
               ClearLine(12);
               GoToXY(1,12);
               Write('Yr = ',YrCtr:3,' Juv = ',Totals[YrCtr]^[0] : 3,
                     ' SubAdults = ',Totals[YrCtr]^[1] : 3,' Adults = ',Totals[YrCtr]^[2] : 3,
                     ' Inbreeding = ',GenesLost[YrCtr]:7:3);
END;
PROCEDURE SetMenuColors(VAR M : Menu);
          BEGIN
               M.BackAtt  := Video1;
               M.TextAtt  := Video2;
               M.HiAtt    := HiVid;
END;
PROCEDURE SimSetColors;
          BEGIN
               SetMenuColors(ChangePar);
               SetMenuColors(DispGraph);
               SetMenuColors(DispOut);
               SetMenuColors(OutRed);
               SetMenuColors(ScreenCh);
               SetMenuColors(EmptyMenu);
END;
BEGIN
END.