PROGRAM TestBeta;
USES Crt,Math,Graph,beta;

CONST
   TOL = 1.0E-15;

VAR
   i   : byte;
   err1,err2 : integer;
   mu, sigma, Mean, sd :extended;
   outf :text;
   one,two,three,four,five,six,seven,eight,nine,ten :word;

FUNCTION Betacf(VAR a,b,x : extended) : extended;
  LABEL 1;
  CONST
    itmax = 100;
    eps = 3.0e-7;
  VAR
    ch                    : CHAR;
    tem,qap,qam,qab,em,d,
    bz,bpp,bp,bm,az,app,
    am,aold,ap            : extended;
    m                     : INTEGER;
  BEGIN
    am := 1.0;
    bm := 1.0;
    az := 1.0;
    qab := a+b;
    qap := a+1.0;
    qam := a-1.0;
    bz := 1.0-qab*x/qap;
    FOR m := 1 TO itmax DO BEGIN
      em := m;
      tem := em+em;
      d := em*(b-m)*x/((qam+tem)*(a+tem));
      ap := az+d*am;
      bp := bz+d*bm;
      d := -(a+em)*(qab+em)*x/((a+tem)*(qap+tem));
      app := ap+d*az;
      bpp := bp+d*bz;
      aold := az;
      am := ap/bpp;
      bm := bp/bpp;
      az := app/bpp;
      bz := 1.0;
      IF ((abs(az-aold)) < (eps*abs(az))) THEN GOTO 1;
    END;
    Writeln;
    Writeln('*** Problem in FUNCTION Betacf: a or b too big, or itmax ',
            'too small. ***');
    Writeln('    Press ESC to quit, any other key to continue.');
    ch := Readkey;
    IF ch = #27 THEN Halt
                 ELSE err2 := 1;
1:
    Betacf := az
  END;

PROCEDURE Betai(VAR a,b,x,ibeta,fx: extended);
  VAR
    ch                      : CHAR;
    bt,compx,gamratio       : extended;
  BEGIN
    IF ((x < 0.0) OR (x > 1.0)) THEN BEGIN
      Writeln;
      Writeln('*** Problem in FUNCTION Betai: x < 0 or > 1. ***');
      Writeln('  Press ESC to quit, any other key to continue.');
      ch := Readkey;
      IF ch = #27 THEN Halt
                   ELSE err1 := 1;
    END;
    gamratio := LnGammaFn(a+b)-LnGammaFn(a)-LnGammaFn(b);
    IF ((x = 0.0) OR (x = 1.0)) THEN BEGIN
      bt := 0.0;
      fx := 0.0; END
    ELSE BEGIN
      bt := Exp(gamratio+a*Ln(x)+b*Ln(1.0-x));
      fx := Exp(gamratio+(a-1)*Ln(x)+(b-1)*Ln(1-x));
    END;
    IF (x < ((a+1.0)/(a+b+2.0))) THEN
      ibeta := bt*Betacf(a,b,x)/a
    ELSE BEGIN
      compx := 1-x;
      ibeta := 1.0-bt*Betacf(b,a,compx)/b;
    END;
  END;

PROCEDURE ComputeAB(Mu,Sigma : extended;VAR a,b : extended);

VAR
   MuVal : extended;
BEGIN
   Muval := (1-Mu)/Mu;
   a := (Muval/(Sqr(Sigma*(1+Muval)))-1)/(1+Muval);
   b := a*Muval;
END;

{PROCEDURE Bisect(u, mu,sigma:extended; VAR x:extended);

VAR
    a, b, ULim, LLim, ibeta,fx : extended;

BEGIN
   ComputeAB(mu,sigma,a,b);
   LLim := 0.0;
   ULim := 1.0;
   REPEAT
      x := (LLim +ULim)/2;
      Betai(a,b,x,ibeta,fx);
      If (ibeta <= u) Then
         LLim := x
      ELSE ULim := x;
   UNTIL (ABS(ibeta-u)< TOL);
END;}

PROCEDURE Moments(mu,sigma:extended; VAR mean, sd :extended;VAR one,two,three,four,five,six,seven,eight,nine,ten:WORD);
VAR
   ct : word;
   Total,SS, x,u: extended;

BEGIN
   Total := 0.0;
   SS := 0.0;
   one := 0;
   two := 0;
   three := 0;
   four := 0;
   five := 0;
   six  := 0;
   seven := 0;
   eight:= 0;
   nine := 0;
   ten := 0;
   FOR ct := 1 to 1000 DO BEGIN
     u := Random;
     Bisect(u,mu,sigma,x);
     If (x <= 0.1) then
        one := one + 1
     Else IF (x <= 0.2) then
        two := two + 1
     Else If (x <= 0.3) then
        three := three + 1
     Else IF (x <= 0.4) then
        four := four +1
     Else If (x <= 0.5) then
        five := five + 1
     Else IF (x <= 0.6) then
        six := six + 1
     Else IF (x <= 0.7) then
        seven := seven + 1
     Else IF (x <= 0.8) then
        eight := eight +1
     Else IF (x <= 0.9) then
        nine := nine + 1
     Else ten := ten +1;
     Total := Total + x;
     SS := SS + sqr(mu - x);
   END;
   Mean := Total/ct;
   sd := sqrt(SS/ct);
   writeln(one:4,two:4,three:4,four:4,five:4,six:4,seven:4,eight:4,nine:4);
END;

BEGIN
     ASSIGN(outf, 'd:\BETA\test3.out');
     REWRITE(outf);
     mu := 0.35;
     sigma := 0.15;
  
         Moments(mu, sigma,mean,sd,one,two,three,four,five,six,seven,eight,nine,ten);
         writeln(mean,sd);
         writeln(outf, 'mu := ', mu:4:2, ' sigma := ', sigma:4:2);
         writeln(outf, 'the mean is ', mean:16:14);
         writeln(outf, 'the standard deviation is ', sd:16:14);
         writeln(outf);
         writeln(outf, 'FREQUENCIES: Range is divided into tenths:');
         writeln(outf, '0-0.1  0.1-0.2  0.2-0.3 0.3-0.4 0.4-0.5 0.5-0.6 0.6-0.7 0.7-0.8 0.8-0.9 0.9-1.0');
         writeln(outf,one:5,two:10,three:8,four:8,five:8,six:8,seven:8,eight:8,nine:8,ten:8);
     CLOSE(outf);
END.
       