{Owl is a simple shell program that goes around all of the rest}

{$R-,S-,V-,I-,N+,E+,G-}
{$M 5000,0,0}
USES Crt,ScrLib,Utility,Dos;

VAR
   FirstColor,SecondColor,ThirdColor,ErrorColor : Byte;

        CONST
             Max_Comment_Ln = 60;    {make these as small as possible}
             Max_Menu       = 8;
             Max_Menu_St    = 8;
        TYPE
            CommentString = String[Max_Comment_Ln];
            MenuString    = String[Max_Menu_St];
            WordArr       = Array[1..80] OF Word;
            StrArr        = Array[1..Max_Menu] OF MenuString;
            MsgArr        = Array[1..Max_Menu] OF CommentString;
            PositionArr   = Array[1..Max_Menu] OF Byte;
            Menu = RECORD
                 FirstLine   : StrArr;       {the top line}
                 SecondLine  : MsgArr;       {associated messages}
                 FstCharSet  : MenuString;   {all of the first letters}
                 Locations   : PositionArr;  {empty at initialization}
                 EntryNo     : Byte;         {number of choices on line 1}
                 Position    : Byte;         {where the bar starts}

                 {Att = background * 16 + forground}

                 TopLineAtt  : Byte;         {various colors}
                 BotLineAtt  : Byte;
                 FstCharAtt  : Byte;
                 LightBar    : Byte;
                 FirstBar    : Byte;
            END;

{Menus here as DSC}

{Once you have the basic setup, you can whip out menus}

  CONST
          Menu1 : Menu =
                  (FirstLine : ('GIS','Map','Rules','Simulate','Analyze',
                                'Class','Bind','Quit');
                  SecondLine : ('Create polygon grid for input into GIS',
                                'Create or change a map file',
                                'Alter or view simulation rules',
                                'Simulate owl demographics',
                                'Create and view condensed output data from multiple runs',
                                'Change the look of the map',
                                'Create a stack of maps for dynamic vegetation',
                                'Exit program');
                  FstCharSet   : 'GMRSACBQ';
                  Locations    : (0,0,0,0,0,0,0,0);
                  EntryNo      : 8;
                  Position     : 1;     {initialize bar to start at position 1}
                  TopLineAtt   : 7;     {start with monochrome colors}
                  BotLineAtt   : 15;
                  FstCharAtt   : 15;
                  LightBar     : 112;
                  FirstBar     : 1);

        VAR

           {the result of choice in the menu is returned in Ch}

           Ch,ExtCh                   : Char;


(***** Procedures begin here *****)
{here is a simple timer that outputs data in seconds/hundreds}
CONST
     TimeHolder : LongInt = 0;

PROCEDURE SetTimer;
          VAR
             h,m,s,Hu : Word;
          BEGIN
               GetTime(h,m,s,Hu);
               TimeHolder := LongInt(h) * 360000 + LongInt(m) * 6000 +
                             LongInt(s) * 100 + LongInt(Hu);
END;
FUNCTION TimeElapsed : Real;
          VAR
             h,m,s,Hu : Word;
          BEGIN
               GetTime(h,m,s,Hu);
               TimeElapsed := ((LongInt(h) * 360000 + LongInt(m) * 6000 +
                               LongInt(s) * 100 + LongInt(Hu))
                               - TimeHolder) * 0.01;
END;


{GetKeys makes sure that extended keystrokes do not hang}

PROCEDURE GetKeys(VAR Ch,EscCh : Char);
           BEGIN
                EscCh := #0;
                Ch := UpCase(ReadKey);
                IF Ch = #0 THEN
                   EscCh := ReadKey;
END;

{ClrLine uses CharToScreen to fill a line with blanks}

PROCEDURE ClrLine(LineNo,Att : Byte);
          BEGIN
               CharToScreen(Pred(LineNo) * 160,80,#32,Att);
END;

{HighLightWrite Writes a string and highlights the first letter}

PROCEDURE HighLightWrite(Posit : Word;Att,HighAtt : Byte; VAR St : String);
          BEGIN
               FastWrite(Posit,Att,St);
               SetAttr(Posit,1,HighAtt);
END;

{BarAttribute writes a highlighted light bar}

PROCEDURE BarAttribute(Posit,Length : Word;FirstAtt, Att : Byte);
          BEGIN
               SetAttr(Posit,Length,Att);
               SetAttr(Posit,1,FirstAtt);
END;

{WriteFirstLine spaces the first line elements evenly across the line}

PROCEDURE WriteFirstLine(VAR Line             : StrArr;
                             StrNo            : Byte;
                         VAR StartPos         : PositionArr;
                             FirstAtt,Att     : Byte);
          VAR
             Ct,Jump,
             Temp    : Byte;
          BEGIN
               ClrLine(1,Att);                        {blank the line}
               Temp := (80 DIV StrNo) * 2;            {get the skip}
               Jump := 0;
               FOR Ct := 1 TO StrNo DO BEGIN       {write the rest}
                   StartPos[Ct] := Jump;
                   HighlightWrite(Jump,Att,FirstAtt,Line[Ct]);
                   Inc(Jump,Temp);
               END;
END;

{WriteSecondLine clears the second line and writes the message string.}

PROCEDURE WriteSecondLine(VAR Line : MsgArr;Posit,Att : Byte);
          BEGIN
               ClrLine(2,Att);
               FastWrite(160,Att,Line[Posit]);
END;

{MoveLightBar moves the light bar around and checks for appropriate keystrokes}

PROCEDURE MoveLightBar(VAR InputMenu                    : Menu;
                       VAR LetterCh                     : Char);

     VAR
        Ch,EscCh : Char;
     BEGIN
          WITH InputMenu DO BEGIN

               {turn bar on at position Position}

               BarAttribute(Locations[Position],Length(FirstLine[Position]),
                            FirstBar,LightBar);

               {Write the associated message on line2}

               WriteSecondLine(SecondLine,Position,BotLineAtt);

               WHILE TRUE DO BEGIN                          {endless loop}

                     {halt until an appropriate key is hit}

                     REPEAT
                           GetKeys(Ch,EscCh);
                     UNTIL ((CharPos(Ch,FstCharSet) <> 0)
                           OR (EscCh IN [#75,#77])
                           OR (Ch IN [#13,#27]));

                     {turn off bar}

                     BarAttribute(Locations[Position],
                                  Length(FirstLine[Position]),
                                  FstCharAtt,TopLineAtt);

                     {take appropriate action based on the keystroke}

                     CASE Ch OF
                          #0 : BEGIN
                                   CASE EscCh OF
                                        #75 : BEGIN
                                                   Dec(Position);
                                                   IF Position = 0 THEN
                                                      Position := EntryNo;
{move the Light bar}                          END;
                                        #77 : BEGIN
                                                   Inc(Position);
                                                   IF Position > EntryNo THEN
                                                      Position := 1;
                                           END;
                                   END; {case}
                               END;
{Enter hit}             #13 :  BEGIN
                                    LetterCh := FstCharSet[Position];
                                    Exit;
                               END;
{Esc. hit}              #27 :  BEGIN
                                    LetterCh := #27;
                                    Exit;
                               END;
{a first letter hit}     ELSE  BEGIN
                                  LetterCh := Ch;
{move light bar position}         Position := CharPos(Ch,FstCharSet);
                                  Exit;
                               END;
                      END;     {case}

                 {turn the bar back on}

                      BarAttribute(Locations[Position],
                                   Length(FirstLine[Position]),
                                   FirstBar,LightBar);

                 {and write the appropriate message}

                      WriteSecondLine(SecondLine,Position,BotLineAtt);
               END;
          END;
END;

{the whole process is called very simply}

PROCEDURE DoMenu(VAR InputMenu : Menu; VAR OutChar : Char);
          BEGIN
               WITH InputMenu DO BEGIN
                    WriteFirstLine(FirstLine,EntryNo,
                                   Locations,FstCharAtt,
                                   TopLineAtt);
                    MoveLightBar(InputMenu,OutChar);
               END;

END;

{change colors if it is a color monitor}

PROCEDURE ColorChange(VAR InputMenu : Menu);
          BEGIN
               WITH InputMenu DO BEGIN
                    TopLineAtt := 113;
                    BotLineAtt := 112;
                    FstCharAtt := 127;
                    LightBar   := 31;
                    FirstBar   := 28;
               END;
END;


PROCEDURE  IncAndWrite(VAR Posit : Word;Amount : Word;St : String);
           BEGIN
                Inc(Posit,Amount);
                VarFWrite(Posit,TextAttr,St);
END;
{$F+}
function GetCPU:Byte;External;
{$L GetCPU}
{$F-}
Procedure WriteCPUFPU;
          VAR
             CPUType : byte;
             x       : Single;
             Holder  : Byte;
             Ch      : Char;
          begin
               Holder := TextAttr;
               TextAttr := ErrorColor;
              CPUType := GetCPU;
              GoToXY(1,24);
              Case CPUType of
                   1 : Write('Processor = 8088-80186, ');
                   2 : Write('Processor = 80286, ');
                   3 : Write('Processor = 80386, ');
              end;
              x := 5;
              Case Test8087 of
                   0 : Write('No coprocessor');
                   1 : Write('Coprocessor = 8087');
                   2 : Write('Coprocessor = 80287');
                   3 : Write('Coprocessor = 80387');
              end;
              WriteLn;
              If (CPUType < 2) or (Test8087 < 2) then begin
                 Write('Error - you cannot run OWL on this computer '+
                       '- any key to exit');
                 Ch := ReadKey;
                 NormVideo;
                 ClrScr;
                 SetCursorSize(Cursor);
                 Halt;
              end;
              TextAttr := Holder;
end;
PROCEDURE Copyright;
          VAR
             Posit : Word;
BEGIN;
     SetCursorSize(NoCursor);
     ClrScr;
Posit := GetScrPos(1,4);
FastWrite(Posit,TextAttr,'              ');
IncAndWrite(Posit,160,'             o o                      USFS SPOTTED OWL MODEL');
SetAttr(Posit + 74,50,SecondColor);
IncAndWrite(Posit,160,'              ''  ');
IncAndWrite(Posit,160,'            ');
IncAndWrite(Posit,160,'                      By Kevin McKelvey and Jennifer Crocker');
IncAndWrite(Posit,160,'           ');
IncAndWrite(Posit,160,'           ');
IncAndWrite(Posit,160,'           ');
IncAndWrite(Posit,160,'        ԰');
IncAndWrite(Posit,160,'          ');
IncAndWrite(Posit,160,'             ');
IncAndWrite(Posit,480,'    A spatially explicit system for modeling demographics and genetics.');
IncAndWrite(Posit,480,'                        Version 2.00    October, 1992');
Delay(2500);
SetCursorSize(Cursor);
END;
PROCEDURE Explanation;
          VAR
             Posit : Word;
BEGIN
     ClrScr;
     SetCursorSize(NoCursor);
     Posit := GetScrPos(5,5);
FastWrite(Posit,TextAttr,'This modeling system consists of five individual programs: GIS.EXE,');
IncAndWrite(Posit,160,'MAP.EXE, RULES.EXE, SIM.EXE, and ANALYZE.EXE.  Map allows you to create a');
IncAndWrite(Posit,160,'map of a specific land configuration and to place owls. Rules allows you');
IncAndWrite(Posit,160,'to modify the rules that govern model behavior. Sim performs the');
IncAndWrite(Posit,160,'simulation. If you perform multiple runs, Analyze will produce');
IncAndWrite(Posit,160,'condensed output. Any of these programs can be run individually -');
IncAndWrite(Posit,160,'OWL.EXE is simply a shell installed for the sake of convenience.');
IncAndWrite(Posit,480,'NOTE: To run this program you MUST have a computer equipped with a');
SetAttr(Posit,4,ThirdColor);
IncAndWrite(Posit,160,'80286, 80386 or 80486 processor and an 80x87 coprocessor.  To use');
IncAndWrite(Posit,160,'any of the graphics you MUST have an EGA, VGA or MDA system.  Without one');
IncAndWrite(Posit,160,'of these graphics systems you will not be able to use Map at all and');
IncAndWrite(Posit,160,'will not be able to watch the simulation or view any of the output');
IncAndWrite(Posit,160,'graphs.  You will, however, be able to create your own map files (The');
IncAndWrite(Posit,160,'documentation contains directions) and generate output files.');
WriteCPUFPU;
END;
PROCEDURE ExecuteProgram(Ch : Char);
          VAR
              Ch1,ExtCh : Char;
          BEGIN
               SetCursorSize(Cursor);
               DosError := 0;
               CASE Ch OF
                    'G' : begin
                               SwapVectors;
                               Exec('Gis.Exe','');
                               SwapVectors;
                          end;
                    'R' : begin
                               SwapVectors;
                               Exec('Rules.Exe','');
                               SwapVectors;
                          end;
                    'M' : begin
                               SwapVectors;
                               Exec('Map.Exe','');
                               SwapVectors;
                          end;
                    'S' : BEGIN
                               SetTimer;
                               SwapVectors;
                               Exec('Sim.Exe','');
                               SwapVectors;
                               IF DosError = 0 THEN BEGIN
                                  GoToXY(20,12);
                                  Write('The simulation took ',TimeElapsed:10:2,
                                  ' seconds');
                                  GoToXY(20,14);
                                  Write('Any key to continue');
                                  GetKeys(Ch1,ExtCh);
                               END;
                          END;
                    'A' : begin
                               SwapVectors;
                               Exec('Analyze.Exe','');
                               SwapVectors;
                          end;
                    'C' : begin
                               SwapVectors;
                               Exec('Class.Exe','');
                               SwapVectors;
                          end;
                    'B' : begin
                               SwapVectors;
                               Exec('Binder.Exe','');
                               SwapVectors;
                          end;
               END;
               IF DosError <> 0 THEN BEGIN
                  GoToXY(20,12);
                  Write('Error in executed file - Press any key to continue');
                  GetKeys(Ch,ExtCh);
               END;
END;

{*************Main Program******************}

BEGIN
     IF Color THEN BEGIN
        TextAttr    := 31;
        Firstcolor  := 31;
        SecondColor := 30;
        ThirdColor  := 28;
        ErrorColor  := 79;
        Colorchange(Menu1);
     END
     ELSE BEGIN
          TextAttr    := 7;
          FirstColor  := 7;
          SecondColor := 15;
          ThirdColor  := 112;
          ErrorColor  := 112;
     END;
     Copyright;
     Explanation;
     REPEAT
           SetCursorSize(NoCursor);
           DoMenu(Menu1,Ch);
           NormVideo;
           ClrScr;
           ExecuteProgram(Ch);
           TextAttr := FirstColor;
           ClrScr;
           SetCursorSize(Cursor);
     UNTIL Ch IN ['Q',#27];
     Normvideo;
     ClrScr;
END.




