
UNIT PrintSc2;
INTERFACE

USES Printer,Crt,Graph;

PROCEDURE PrintScreen(Landscape : Boolean;Device : Word;Err : Boolean);

IMPLEMENTATION

TYPE
    ScreenLine = Array[1..720] OF Byte;
PROCEDURE SetGraphics(VAR Err : Boolean);
          BEGIN
               Write(Lst,#27'A'#8);
               Err := IOResult <> 0;
END;
PROCEDURE RemoveGraphics(VAR Err : Boolean);
          BEGIN
               Write(Lst,#27'@');
               Err := IOResult <> 0;
END;
PROCEDURE GraphLine(    N                               : Word;
                    VAR X                               : ScreenLine;
                    VAR Err                             : Boolean);
          VAR
             Ct      : Word;
             Ct2,Rep : Byte;
          BEGIN
               Write(Lst,#27#42);
               CASE N OF
                  720 : Write(Lst,#6#208#2);
                  640 : Write(Lst,#4#128#2);
                  480 : Write(Lst,#1#192#3);
                  350 : Write(Lst,#6#188#2);
                  348 : Write(Lst,#6#184#2);
               END;
               IF N >= 640 THEN
                  Rep := 1
               ELSE
                   Rep := 2;
               FOR Ct := 1 TO N DO
                   FOR Ct2 := 1 TO Rep DO
                       Write(Lst,Char(X[Ct]));
               WriteLn(Lst);
               Err := IOResult <> 0;
END;
PROCEDURE FinishPage(Ct : Word; VAR Err : Boolean);
          VAR
             Ct2 : Word;
          BEGIN
               FOR Ct2 := Ct TO 89 DO
                   WriteLn(Lst);
               RemoveGraphics(Err);
END;
PROCEDURE PrintScreen(Landscape : Boolean;Device : Word;Err : Boolean);
          VAR
             Rows,Col      : Word;
             Ct,Ct2        : Word;
             Y,YCtr,
             X,XCtr        : Word;
             BitCtr,OutBit : Byte;
             Arr           : ScreenLine;
             Ch            : Char;
          BEGIN
               SetGraphics(Err);
               IF Err THEN Exit;
               IF Landscape THEN BEGIN
                  X := 640;
                  Rows := 80;
                  IF Device = 3 THEN
                     Col := 350
                  ELSE IF Device = 9 THEN
                       Col := 480
                  ELSE IF Device = 7 THEN BEGIN
                       Col := 348;
                       X   := 720;
                       Rows := 90;
                  END;
                  FOR Ct := 1 TO Rows DO BEGIN
                      FOR Ct2 := 1 TO Col DO BEGIN
                          OutBit := 0;
                          XCtr   := X;
                          FOR BitCtr := 7 DOWNTO 0 DO BEGIN
                              IF GetPixel(XCtr,Pred(Ct2)) <> 0 THEN
                                 OutBit := OutBit OR (1 SHL BitCtr);
                              Dec(XCtr);
                          END;
                          Arr[Ct2] := OutBit;
                      END;
                      Dec(X,8);
                      GraphLine(Col,Arr,Err);
                      IF Err THEN
                         Exit;
                      IF Keypressed THEN BEGIN
                         Ch := ReadKey;
                         IF Ch = #27 THEN BEGIN
                            FinishPage(Ct,Err);
                            Exit;
                         END
                         ELSE IF Ch = #0 THEN
                              Ch := ReadKey;
                      END;
                  END;
               END
               ELSE BEGIN
                    Col := 640;
                    IF Device = 3 THEN
                       Rows := 43
                    ELSE IF Device = 9 THEN
                         Rows := 60
                    ELSE IF Device = 7 THEN BEGIN
                         Rows := 43;
                         Col := 720;
                    END;
                    Y := 0;
                    FOR Ct := 1 TO Rows DO BEGIN
                        FOR Ct2 := 1 TO Col DO BEGIN
                            OutBit := 0;
                            YCtr   := Y;
                            FOR BitCtr := 7 DOWNTO 0 DO BEGIN
                                IF GetPixel(Pred(Ct2),YCtr) <> 0 THEN
                                   OutBit := OutBit OR (1 SHL BitCtr);
                                Inc(YCtr);
                            END;
                            Arr[Ct2] := OutBit;
                        END;
                        Inc(Y,8);
                        GraphLine(Col,Arr,Err);
                        IF Err THEN Exit;
                        IF Keypressed THEN BEGIN
                           Ch := ReadKey;
                           IF Ch = #27 THEN BEGIN
                              FinishPage(Ct,Err);
                              Exit;
                           END
                           ELSE IF Ch = #0 THEN
                                Ch := ReadKey;
                        END;
                    END;
            END;
            FinishPage(Ct,Err);
END;
BEGIN
END.




