
{$A+,B-,D+,E-,F-,G-,I-,L+,N+,O-,R-,S-,V-,X-}
{$M 16384,0,655360}
USES ScrLib,Global,Menus,RuleSet,Crt,ClassDef, IncBeta2;


VAR
   Ch      : Char;
   Changed : Boolean;
CONST
ChooseRules  : Menu = (StartX   : 33;
                       StartY   : 11;
                       BackAtt  : 7;
                       TextAtt  : 7;
                       HiAtt    : 15;
                       N        : 4;
                       PosArr   : (1,1,6,1,1);
                       StrArr   : ('Change Parameters',
                                   'View Parameters',
                                   'View Distribution',
                                   'Quit','');
                       LetterSet : ['C','V','D','Q',#27]);
ChooseBlock  : Menu = (StartX   : 33;
                       StartY   : 11;
                       BackAtt  : 7;
                       TextAtt  : 7;
                       HiAtt    : 15;
                       N        : 5;
                       PosArr   : (1,1,1,1,1);
                       StrArr   : ('Survival Parameters',
                                   'Fledge Parameters',
                                   'Movement Parameters',
                                   'Time Series Parameters','Quit');
                       LetterSet : ['S','F','M','T','Q',#27]);
TitleArr : Array
[1..8] OF String[50] =
           ('Annual Mean Survival Probability  For Stage ',
            'Variance in Survival Probability For Stage ',
            'Mean fledge probability in stage ',
            'Variance in fledge probability in stage ',
            'Land class Ok for nesting',
            'Aversion to entering land class',
            'Propensity to move on',
            'Probability a widowed male keeps territory');
HiLo       : Array[1..7, 1..2] OF Real =
             ((0,1),(0,0.25),(0,1),(0,1),(0,1),(0,10),(0,100));



PROCEDURE InputRealArrMenu(TitleNo, StageNo : Byte;VAR Arr : RealCriteria);

          VAR
             Ct    : Word;
             Posit : Word;
             EscSw : Boolean;
             StageNoStr : String[5];
             Title : String[50];
             VarLimit : LimitType;

          CONST
             St    : String[8] = '--------' ;

          BEGIN
               SetVarLimits(VarLimit,StageNo);
               SetCursorSize(NoCursor);
               ClrScr;
               CenterText(20,RevVid2,'Hit <ESC> when through');
               If (TitleNo < 5) Then BEGIN
                  Str(StageNo, StageNoStr);
                  Title := Concat(TitleArr[TitleNo],StageNoStr );
               END
               ELSE
                  Title := TitleArr[TitleNo];
               CenterText(2,Video1,Title );
               Posit := GetScrPos(1,8);
               FOR Ct := 1 TO 8 DO BEGIN
                   VarFWrite(Posit,Video1,ClassTitle[Ct]);
                   Inc(Posit,20);
               END;
               GoToXY(1,9);
               FOR Ct := 1 TO 8 DO BEGIN
                   Write(Arr[Ct]:8:2,'  ');
               END;
               Posit := GetScrPos(1,11);
               FOR Ct := 1 TO 8 DO BEGIN
                   VarFWrite(Posit,Video1,St);
                   Inc(Posit,20);
               END;
               Posit := 1;
               SetCursorSize(Cursor);
               Ct := 0;
               REPEAT
                     Inc(Ct);
                     IF (TitleNo = 2) OR (TitleNo = 4) THEN
                         HiLo[TitleNo, 2] := VarLimit[TitleNo div 2,Ct];
                     EscSw := InputReal(Posit,10,8,2,HiLo[TitleNo,1],HiLo[TitleNo,2],
                                        Arr[Ct]);
                     Inc(Posit,10);
               UNTIL EscSw OR (Posit > 80);
               IF (TitleNo = 1) OR (TitleNo = 3) THEN
                  SetVarLimits(VarLimit, StageNo);
END;
{
PROCEDURE InputIntArrMenu(ArrNo : Byte;VAR Arr : AcceptCriteria);
          VAR
             Ct      : Word;
             Posit   : Word;
             EscSw   : Boolean;
             Holder  : Integer;
          CONST
             St    : String[8] = '--------';
          BEGIN
               SetCursorSize(NoCursor);
               ClrScr;
               CenterText(20,RevVid2,'Hit <ESC> when through');
               CenterText(1,Video1,TitleArr[ArrNo]);
               Posit := GetScrPos(1,8);
               FOR Ct := 1 TO 8 DO BEGIN
                   VarFWrite(Posit,Video1,ClassTitle[Ct]);
                   Inc(Posit,20);
               END;
               GoToXY(1,9);
               FOR Ct := 1 TO 8 DO BEGIN
                   Write(Arr[Ct]:8,'  ');
               END;
               Posit := GetScrPos(1,11);
               FOR Ct := 1 TO 8 DO BEGIN
                   VarFWrite(Posit,Video1,St);
                   Inc(Posit,20);
               END;
               Posit := 1;
               SetCursorSize(Cursor);
               Ct := 0;
               REPEAT
                     Inc(Ct);
                     Holder := Arr[Ct];
                     EscSw := InputInteger(Posit,10,8,HiLo[ArrNo,1],
                                           HiLo[ArrNo,2],Holder);
                     Arr[Ct] := Holder;
                     Inc(Posit,10);
               UNTIL EscSw OR (Posit > 80);
END;
 }
PROCEDURE GetRealVal(X,Y,Decimals       : Byte;
                    Lo,Hi              : Integer;
                    St                 : String;
                    VAR Value              : Single);
         VAR
            EscSw  : Boolean;
         BEGIN
              ClrScr;
              GoToXY(1,Y);
              Write(St,'  Default = ',Value:8:Decimals,' :');
              EscSw := InputReal(X,Y,8,Decimals,Lo,Hi,Value);
END;
PROCEDURE GetWordVal(X,Y               : Byte;
                    Lo,Hi              : Integer;
                    St                 : String;
                    VAR Value          :  Word);
         VAR
            Holder : Integer;
            EscSw  : Boolean;

         BEGIN
              ClrScr;
              Holder := Value;
              GoToXY(1,Y);
              Write(St,'  Default = ',Value:8,' :');
              EscSw := InputInteger(X,Y,8,Lo,Hi,Holder);
              Value := Holder;
END;
PROCEDURE GetByteVal(X,Y                : Byte;
                    Lo,Hi              : Integer;
                    St                 : String;
                    VAR Value              :  Byte);
         VAR
            Holder : Integer;
            EscSw  : Boolean;
         BEGIN
              ClrScr;
              Holder := Value;
              GoToXY(1,Y);
              Write(St,'  Default = ',Value:8,' :');
              EscSw := InputInteger(X,Y,8,Lo,Hi,Holder);
              Value := Holder;
END;
PROCEDURE GetSurvivals;
          VAR
             Ct : Word;
BEGIN
     FOR Ct := 0 TO (Stages - 1) DO
         InputRealArrMenu(1, ct, SurvivalMean[ct]);
     FOR Ct := 0 TO (Stages- 1) DO
         InputRealArrMenu(2, ct,   SurvivalVar[ct]);
    
END;

PROCEDURE GetFledge;
          VAR
             Ct : Word;
             EscSw :Boolean;
BEGIN
     FOR Ct := 0 TO (Stages-1) DO
        InputRealArrMenu(3, ct, FledgeMean[ct]);
     FOR Ct := 0 To (Stages-1) DO
        InputRealArrMenu(4, ct, FledgeVar[ct]);
     GetByteVal(70,12,0,10,'The number of young per pair', FledgeNo);
     GetRealVal(70,12,2,0,1,'The proportion of males born',MaleFledgeProb);
END;
PROCEDURE GetMovement;
          VAR
             Ct : Word;
             EscSw :Boolean;
BEGIN
     FOR Ct := 5 TO 7 DO BEGIN
         CASE Ct OF
             5 : InputRealArrMenu(Ct,0,LandClassOK);
             6 : InputRealArrMenu(Ct, 0, Aversion);
             7 : InputRealArrMenu(Ct,0, WanderLust);
         END;
     END;
     GetRealVal(70,12,2,0,1000,'The directional weight',
                DirectionalWeight);
     GetRealVal(70,12,2,0,1,'The prob. of a female finding an adjacent male',
                FemSearchProb);
     GetRealVal(70,12,2,0,1,'The male''s aversion crossing territories'
                ,PairAversion);
     GetByteVal(70,12,1,3,'The global boundary condition',BoundaryCondition);
END;
PROCEDURE GetTimeSeries;
          VAR
             Ct : Word;
             EscSw :Boolean;
BEGIN
     GetWordVal(70,12,1,1000,'The number of runs',Runs);
     GetWordVal(70,12,1,500,'The number of years per run',Years);
     GetWordVal(70,12,1,1000,'The number of movements per year',DeltaT);
END;
PROCEDURE ChangeParameters;
          VAR
             Ch : Char;
          BEGIN
               ClrScr;
               GetWordVal(70,12, 0, 10,'Enter the number of age classes: ',Stages);
               REPEAT
                     Ch := InputMenu(ChooseBlock);
                     CASE Ch OF
                          'S' : GetSurvivals;
                          'F' : GetFledge;
                          'M' : GetMovement;
                          'T' : GetTimeSeries;
                     END;
               UNTIL Ch IN ['Q',#27];
END;
PROCEDURE WriteRules;
          VAR
             i, Ct : Word;
             OutF  : Text;
             EscSw : Boolean;
          BEGIN
               OutputFileName(20,22,Video1,Video2,'The rules file to output : ',
                              OutF,EscSw);
               IF EscSw THEN
                  Exit;
               WriteLn(OutF,-6666);
               Writeln(Outf, Stages);
               FOR i := 0 To (Stages-1) DO BEGIN
                  FOR Ct := 1 TO 8 DO
                      Write(Outf,SurvivalMean[i, Ct]:6:3,' ');
                  Writeln(Outf);
               END;
               FOR i := 0 To (Stages-1) DO BEGIN
                  FOR Ct := 1 TO 8 DO
                     Write(Outf,SurvivalVar[i, ct]:6:3,' ');
                  Writeln(Outf);
               END;
               For i := 0 To (Stages-1) DO BEGIN
                  FOR Ct := 1 TO 8 DO
                     Write(Outf,FledgeMean[i, Ct]:6:3,' ');
                  WriteLn(OutF);
               END;
               FOR i := 0 To (Stages-1) DO BEGIN
                 FOR Ct := 1 TO 8 DO
                    Write(Outf,FledgeVar[i, Ct]:6:3,' ');
                 WriteLn(OutF);
               END;
               WriteLn(OutF,FledgeNo);
               WriteLn(OutF,MaleFledgeProb);
               FOR Ct := 1 TO 8 DO
                   Write(Outf,LandClassOK[Ct]:6:3,' ');
               WriteLn(OutF);
               FOR Ct := 1 TO 8 DO
                   Write(Outf,Aversion[Ct]:6:3,' ');
               WriteLn(OutF);
               WriteLn(OutF,FemSearchProb);
               WriteLn(OutF,PairAversion);
               WriteLn(OutF,DirectionalWeight);
               FOR Ct := 1 TO 8 DO
                   Write(Outf,WanderLust[Ct]:6:3,' ');
               WriteLn(OutF);
               WriteLn(OutF,BoundaryCondition);
               WriteLn(OutF,Runs);
               WriteLn(OutF,Years);
               WriteLn(Outf,DeltaT);
               IF IOResult <> 0 THEN
                  FatalErrors(7);
               Close(OutF);
END;

TYPE
    StringArr = Array[1..9] OF String[10];
CONST
     OwlDataArray   : StringArr =
     ('Juv.','Adults','Pairs','Total','Fledged','J-Died','A-Died',
      'Age','Fix');
FUNCTION MakeDashedLine : String;
         VAR
            TempSt : String;
        BEGIN
             FillChar(TempSt[1],79,'-');
             TempSt[0] := #79;
             MakeDashedLine := Tempst;
END;
FUNCTION MakeStringfield(St : String;FieldWidth : Byte):String;
         VAR
            TempSt : String;
            Ct,Ctr : Byte;
         BEGIN
              FillChar(TempSt[1],FieldWidth,#32);
              TempSt[0] := Char(FieldWidth);
              IF St[0] = #0 THEN
                 MakeStringField := TempSt
              ELSE BEGIN
                  IF Byte(St[0]) > FieldWidth THEN
                     St[0] := Char(FieldWidth);
                  Ctr := Succ(Byte(St[0]));
                  FOR Ct := FieldWidth DOWNTO (FieldWidth - Pred(Byte(St[0]))) DO
                      BEGIN
                      Dec(Ctr);
                      TempSt[Ct] := St[Ctr];
                  END;
                  MakeStringField := TempSt;
             END;

END;
FUNCTION MakeIntegerField(X : Integer;FieldWidth : Byte):String;
         VAR
            TempSt : String;
         BEGIN
              IF X = 0 THEN BEGIN
                 FillChar(TempSt[1],FieldWidth,#32);
                 TempSt[0] := Char(FieldWidth);
                 TempSt[Length(TempSt)] := '-';
              END
              ELSE
                   Str(X:FieldWidth,TempSt);
              MakeIntegerField := TempSt;
END;
FUNCTION MakeIntegerField2(X : Integer;FieldWidth : Byte):String;
         VAR
            TempSt : String;
         BEGIN
              IF X = 0 THEN BEGIN
                 FillChar(TempSt[1],FieldWidth,#32);
                 TempSt[0] := Char(FieldWidth);
                 TempSt[Length(TempSt)] := '0';
              END
              ELSE
                   Str(X:FieldWidth,TempSt);
              MakeIntegerField2 := TempSt;
END;
FUNCTION MakeRealField(X : Single;FieldWidth,Decimals : Byte):String;
         VAR
            TempSt : String;
         BEGIN
              IF X = 0 THEN BEGIN
                 FillChar(TempSt[1],FieldWidth,#32);
                 TempSt[0] := Char(FieldWidth);
                 TempSt[Length(TempSt)] := '-';
              END
              ELSE
                   Str(X:FieldWidth:Decimals,TempSt);
              MakeRealField := TempSt;
END;
FUNCTION MakeRealField2(X : Single;FieldWidth,Decimals : Byte):String;
         VAR
            TempSt : String;
         BEGIN
              Str(X:FieldWidth:Decimals,TempSt);
              MakeRealField2 := TempSt;
END;
FUNCTION MakeCenteredString(St : String):String;
         VAR
            TempSt : String;
            Start  : Byte;
            Ct,Ctr : Byte;
         BEGIN
              IF St[0] > #78 THEN
                 St[0] := #78;
              Start := (80 - Byte(St[0])) SHR 1;
              FillChar(TempSt[1],80,#32);
              TempSt[0] := Char(Start + Pred(Byte(St[0])));
              Ctr := 0;
              FOR Ct := Start TO (Pred(Start) + Byte(St[0])) DO BEGIN
                  Inc(Ctr);
                  TempSt[Ct] := St[Ctr];
              END;
              MakeCenteredString := TempSt;
END;
PROCEDURE WriteRealClassData(    St    : String;
                             VAR Arr   : RealCriteria;
                                 Field : Byte);
          VAR
             Ct : Byte;
          BEGIN
               Write(MakeStringField(St,Field));
               FOR Ct := 1 TO LandScapeClasses DO
                   Write(MakeRealField(Arr[Ct],Field,2));
               WriteLn;
END;
PROCEDURE WriteIntClassData(     St    : String;
                             VAR Arr   : AcceptCriteria;
                                 Field : Byte;
                                 Decimals :Byte);
          VAR
             Ct : Byte;
          BEGIN
               Write(MakeStringField(St,Field));
               FOR Ct := 1 TO LandScapeClasses DO
                   Write(MakeRealField(Arr[Ct],Field,Decimals));
               WriteLn;
END;
PROCEDURE StartDataType(    St    : String;
                            Arr   : ClassNameArr;
                            N     : Byte;
                            Field : Byte);
          VAR
             Ct        : Byte;
             AttHolder : Byte;
          BEGIN
          AttHolder := TextAttr;
          TextAttr := Video1;
          WriteLn(MakeDashedLine);
          Write(MakeStringField(St,Field));
          FOR Ct := 1 TO N DO
              Write(MakeStringField(Arr[Ct],Field));
          WriteLn;
          WriteLn(MakeDashedLine);
          TextAttr := AttHolder;

END;
FUNCTION DispBoundary : String;
         BEGIN
              CASE BoundaryCondition OF
                   1 : DispBoundary := 'Reflecting';
                   2 : DispBoundary := 'Absorbing';
                   3 : DispBoundary := 'Wrap-Around';
              END;
END;
PROCEDURE WriteInitData;
   VAR
      Ct,Field : Byte;
      OnOff    : Byte;
      Ch,ExtCh : Char;
      StageNo  : String[2];
      Title    : String[10];
   BEGIN
        SetCursorSize(NoCursor);
        OnOff := 0;
        REPEAT
               IF OnOff = 0 THEN  BEGIN
                 ClrScr;
                 CenterText(25,63,'Hit <ESC> to quit, any key for more');
                 Field := 80 DIV Succ(LandscapeClasses);
                 WriteLn(MakeCenteredString('START UP PARAMETERS'));
                 WriteLn;
                 StartDataType('',ClassNameArray,LandscapeClasses,Field);
                 Writeln('NUMBER OF AGE CLASSES = ', Stages);
                 WriteLn('MEAN SURVIVAL PROBABILITIES');
                 FOR ct := 0 To (Stages-1) DO BEGIN
                    Str(ct, StageNo);
                    Title   := Concat('Stage ', StageNo);
                    WriteRealClassData(Title, SurvivalMean[ct],Field);
                 END;
                 Writeln('VARIANCE OF SURVIVAL PROBABILITIES');
                 FOR ct := 0 To (Stages-1) DO BEGIN
                    Str(ct, StageNo);
                    Title   := Concat('Stage ', StageNo);
                    WriteRealClassData(Title, SurvivalVar[ct],Field);
                 END;
              END
              ELSE IF ONOff = 1 THEN BEGIN
                 ClrScr;
                 CenterText(25,63,'Hit <ESC> to quit, any key for more');
                 WriteLn(MakeCenteredString('START UP PARAMETERS'));
                 WriteLn;
                 StartDataType('',ClassNameArray,LandscapeClasses,Field);
                 WriteLn('MEAN FLEDGE PROBABILITIES');
                 FOR ct := 0 To (Stages-1) DO BEGIN
                    Str(ct, StageNo);
                    Title   := Concat('Stage ', StageNo);
                    WriteRealClassData(Title, FledgeMean[ct],Field);
                 END;
                 writeln('VARIANCE IN FLEDGE PROBABILITY');
                 FOR ct := 0 To (Stages-1) DO BEGIN
                    Str(ct, StageNo);
                    Title   := Concat('Stage ', StageNo);
                    WriteRealClassData(Title, FledgeVar[ct],Field);
                 END;
                 WriteLn('Fledge Number  = ',FledgeNo);
                 WriteLn('Male Prob. of Fledging = ',MaleFledgeProb:4:2);
               END
               ELSE BEGIN
                 ClrScr;
                 CenterText(25,63,'Hit <ESC> to quit, any key to go back');
                 WriteLn(MakeCenteredString('START UP PARAMETERS'));
                 WriteLn;
                 StartDataType('',ClassNameArray,LandscapeClasses,Field);
                 WriteLn('MOVEMENT');
                 WriteLn;
                 WriteIntClassData('Nesting OK',LandClassOK,Field,2);
                 WriteRealClassData('Aversion',Aversion,Field);
                 WriteRealClassData('WanderL',WanderLust,Field);
                 WriteLn('Prob. Female Finds Male   = ',FemSearchProb:4:2);
                 WriteLn('Male Territorial Aversion = ',PairAversion:4:2);
                 WriteLn('Directionial Weighting    = ',DirectionalWeight:4:2);
                 WriteLn('Boundary Condition        = ',DispBoundary);
                 WriteLn(MakeDashedLine);
                 WriteLn('TIME SERIES');
                 WriteLn;
                 WriteLn('Total number of runs = ',Runs);
                 WriteLn('Total run length     = ',Years,' Years');
                 WriteLn('Delta-t              = ',DeltaT);
              END;
              GetKeys(Ch,ExtCh);
              OnOff :=  Succ(OnOff) MOD 3;
        UNTIL Ch = #27;
END;

PROCEDURE ChooseDistribution(Posit: Byte; meanarr, vararray :RealMatrix);
VAR
   Age, Class : Integer;
   EscSw : Boolean;
   a,b:double;
   ZeroDen : Boolean;
   ch      : char;
BEGIN
   Age := 0;
   Class := 1;
   Write('Enter The Age: ');
   EscSw := InputInteger(16,Posit,1,0,Stages-1, Age);
   IF EscSw THEN Exit
   ELSE  BEGIN
      WriteLn;
      Write('Enter The LandClass: ');
      EscSw := InputInteger(22, Posit + 1,1,1,LandScapeClasses,Class);
   END;
   ZeroDen := (Meanarr[age,class] = 0) OR (VarArray[Age,Class] = 0);
   IF NOT EscSw THEN BEGIN
      gd := 0;
      gm := 0;
      IF NOT ZeroDen THEN BEGIN
        ComputeAB(meanarr[age,class],vararray[age,class],
               a,b);
        GetBetaVal(FunctN,a,b,xdec,y1dec,y2dec,ymax,error);
      END;
      InitGraphics(gd,gm, ZeroDen,meanarr[age,class]);
      IF NOT ZeroDen THEN  BEGIN
        GetPlots(Xarr,yarr);
        drawplots(xarr,yarr,lightgreen);
      END;
      REPEAT
         ch := readkey;
      UNTIL (ch = #27);
      closegraphics;
   END;
END;
PROCEDURE DisplayData(Meanarr, Vararr : RealMatrix; VAR total : Byte; VAR
                               EscSw : Boolean);
VAR
   Ct1,Ct2 : Byte;
   StageNo : String;
   Title   : String;
   Field   : Byte;
   IntArr  : AcceptCriteria;

BEGIN
         Field := 80 DIV Succ(LandscapeClasses);
         WriteLn('Age                             LandClass');
         Title := '';
         FillChar(Title, Succ(Field), #32);
         FOR Ct2 := 1 TO LandscapeClasses DO
           IntArr[Ct2] := Ct2;
         WriteIntClassData(Title, IntArr, Field,0);
         WriteLn(MakeDashedLine);
         Inc(Total, 3);
         FOR ct1 := 0 To (Stages-1) DO BEGIN
                    Str(ct1, Title);
                    FOR Ct2 := 1 TO Field - 5 DO
                       Title := Title + ' ';
                    Title := Title + 'Mean';
                    WriteRealClassData(Title, MeanArr[ct1],Field);
                    Title := 'Variance';
                    WriteRealClassData(Title, VarArr[Ct1], Field);
                    Inc(Total, 2);
                 END;
END;

PROCEDURE ShowDist;
CONST
  DistType      : Menu = (StartX   : 33;
                       StartY   : 11;
                       BackAtt  : 7;
                       TextAtt  : 7;
                       HiAtt    : 15;
                       N        : 3;
                       PosArr   : (1,1,1,1,1);
                       StrArr   : ('Survival Distribution',
                                   'Fledge Distribution',
                                   'Quit','','');
                       LetterSet : ['S','F','Q',#27]);
VAR
  Total : Byte;
  EscSw : Boolean;
  Ch2    : Char;

BEGIN
    SetMenuColors(DistType);
    Repeat
       EscSw := FALSE;
       Ch2 := InputMenu(DistType);
       CASE Ch2 OF
          'S' : BEGIN
                  Total := 0;
                  ClrScr;
                  DisplayData(Survivalmean,survivalvar,total, EscSw);
                  IF EscSw THEN Exit;
                  ChooseDistribution(Total + 1,survivalmean,survivalvar);

                END;
          'F' : BEGIN
                 Total := 0;
                 ClrScr;
                 DisplayData(FledgeMean,FledgeVar,Total, EscSw);
                 IF EscSw THEN Exit;
                 ChooseDistribution(Total + 1,fledgemean,fledgevar);
                END;
        END;
    UNTIL Ch2 IN ['Q', #27];
END;
 
BEGIN
     SetDefaultRules;
     SetColors;
     SetMenuColors(ChooseBlock);
     SetMenuColors(ChooseRules);
     ClrScr;
     GoToXY(20,12);
     Write('Input from a file? (Y/N) :');
     Ch := ReturnYesNo;
     IF Ch = 'Y' THEN
        PickUpRules;
     Changed := FALSE;
     REPEAT
         Ch := InputMenu(ChooseRules);
         CASE Ch OF
              'V' : WriteInitData;
              'D' : ShowDist;
              'C' : BEGIN
                         ChangeParameters;
                         Changed := TRUE;
                    END;
         END;
    UNTIL Ch IN ['Q',#27];
    IF Changed THEN BEGIN
       ClrScr;
       GoToXY(20,12);
       Write('Save output to a file? (Y/N) :');
       Ch := ReturnYesNo;
       IF Ch = 'Y' THEN
          WriteRules;
    END;
    HaltProgram;
END.