{$A+,B-,D+,E-,F-,I-,L+,N+,O-,R-,S+,V-,G-}
{$M 64000,0,655360}
     {$DEFINE COPROC387}
USES Global,Crt,OwlAsm,Dynamics,RuleSet,
     OwlGraph,Output,Menus,Graph,Genes,Demogra,CountPop,
     MultRun,SumStat,Utility, Beta, MeanOcc;

VAR
   Error,SimAgain,MultRuns                       : Boolean;
   MinPop                                        : Word;
   MTE                                           : Distance;{distance mis-}
                                                            {named here}
   Dynamic                                       : Boolean;
   BoundFile                                     : String;
   Extinct                                       : Boolean;
   MOFile                                        : OccupancyFile;
 
PROCEDURE RandomSequence(N : Word;VAR Arr : IndexType);
          VAR
             Ct : Word;
          BEGIN

               Sequence(N,1,1,Arr);
               FOR Ct := 1 TO N DO BEGIN
                   SwapWord(Ct,Succ(RandWord(N)),Arr);
               END;
END;



PROCEDURE GetOutputData(Yr : Word;VAR Pop : Population);
          BEGIN
               CountPopulation(Yr,Pop);
               WITH Pop DO BEGIN
                  PairStartCtr[Yr] := PairCtr;
                  GenesLost[Yr]    := ScanForFixed(Pop);
                  Inc(YrCtr);
          END;
END;
      


PROCEDURE TimeSeries(RunCtr : Word;VAR Pop : Population;FileName : String;
                      VAR Extinct : Boolean);


VAR
   Yr, TypeCtr,MCtr,
   FCtr,
   TimeStep,
   Holder,Ct,OwlPop     : Word;
   MFlag,FFlag,
   EscSw                : Boolean;
   TypeIndx             : TypeIndex;
   b,b1,PopB,PopB1      : Single;

BEGIN

     WITH Pop DO BEGIN
        CountPopulation(0, Pop);
        FOR Yr := 1 TO Years DO BEGIN
            SetBetas;
            DeltaTCounter := 0;
            if Dynamic then
               DoDyamicMap(HabitatWidth,HabitatLength,Yr,Habitat,Pop,FileName);
            if MultRuns then
                 UpdateOccupancy(HabitatWidth,HabitatLength,MOFile);
            IncAge(Pop);
            FledgeAllAdultPairs(Pop, Yr);
            GetOutputData(Yr,Pop);
            OwlPop := PairCtr * 2 + MaleCtr + FemaleCtr;
            if OwlPop < MinPop then
               MinPop := OwlPop;
            IF OwlPop = 0 then begin
               Inc(MTE.N);
               MTE.SumDist := MTE.SumDist + Yr;
               Extinct := TRUE;
               Exit;
            end;
            IF GraphOn THEN
              OutputStats(Yr, PairStartCtr[Yr],Totals[Yr]^[0] + Totals[Yr]^[1], Totals[Yr]^[2])
            ELSE
                YearPop(RunCtr,Yr);

          FOR TimeStep := 1 TO DeltaT DO BEGIN
              KillAllAdultPairs(Pop,Yr);
              Inc(DeltaTCounter);
              RandomSequence(MaleCtr,MIndx);
              RandomSequence(FemaleCtr,FIndx);
              MCtr     := 0;
              FCtr     := 0;
              REPEAT
               Sequence(2,1,1,TypeIndx);
               FOR Ct := 1 TO 2 DO
                   SwapWord(Ct,Succ(RandWord(2)),TypeIndx);
                FOR TypeCtr := 1 TO 2 DO BEGIN
                  CASE TypeIndx[TypeCtr] OF
                        SMale : BEGIN
                                     MFlag := (MCtr >= MaleCtr);
                                     IF NOT MFlag THEN BEGIN
                                        Inc(MCtr);
                                        Holder := MIndx[MCtr];
                                      IF NOT KillTransient(Holder,Pop,
                                             SMale, Yr)
                                        THEN BEGIN
                                        IF NOT (MalePop^[Holder].Settled)
                                           THEN
                                           MaleMove(MalePop^[Holder].
                                                    Column,
                                                    MalePop^[Holder].
                                                    Row,Holder,
                                                    Pop,
                                                    BoundaryCondition);
                                        END;
                                     END;
                                 END;
                      SFemale : BEGIN
                                     FFlag := (FCtr >= FemaleCtr);
                                     IF NOT FFlag THEN BEGIN
                                        Inc(FCtr);
                                        Holder := FIndx[FCtr];
                                      IF NOT KillTransient(Holder,Pop,SFemale,Yr)
                                        THEN BEGIN
                                        FemaleMove(FemalePop^[Holder].
                                                    Column,
                                                    FemalePop^[Holder].
                                                    Row,Holder,
                                                    Pop,
                                                    BoundaryCondition);
                                      END
                                     END;

                                END;
                      
                  END;
                END;
                IF GraphOn THEN BEGIN
                   InterceptKeys(EscSw);
                   IF EscSw THEN BEGIN
                      RestoreTextMode;
                      Exit;
                   END;
                   Delay(GlobalDelay);
                END;
               UNTIL MFlag AND FFlag;
        END;   {timestep}
      END;      {years}
     END;     {with}
END;

Procedure CreateSummaryStats(VAR MTE,Death,Pair : Distance;
                                 MinPop         : Word);
          VAR
             MeanExt,MeanDeath,MeanPair : Single;
          begin
               if MTE.N <> 0 then
                  MeanExt := MTE.SumDist/MTE.N
               Else
                   MeanExt := 0;
               if Death.N <> 0 then
                  MeanDeath := Death.SumDist/Death.N
               Else
                   MeanDeath := 0;
               if Pair.N <> 0 then
                  MeanPair := Pair.SumDist/Pair.N
               Else
                   MeanPair := 0;
               CreateSumStatsFile(MeanExt,MeanDeath,MeanPair,MinPop,MTE.N,
                                  GlobOutFileName);
end;

PROCEDURE MultipleRuns;
          VAR
             Outf  : Text;
             Ct    : Word;
             EscSw : Boolean;
             Extinct : Boolean;
          BEGIN
                MultRuns := True;
                PlaceTempFile;
                OutputfileName(20,22,Video2,Video1,'The raw output file : ',OutF,EscSw);
                ClrScr;
                EscSw := FALSE;
                IF EscSw THEN
                   Exit;
                OutputRules(GlobOutFileName);
                InitializeFile(HabitatWidth,HabitatLength,MOFile,GlobOutFileName);
                InitializePop(Owls,Error);
                IF Error THEN
                   FatalErrors(3);
                Randomize;
                FOR Ct := 1 TO Runs DO BEGIN
                   ZeroEverything;
                   Extinct := FALSE;
                   IF Ct <> 1 THEN
                      RetrieveTempFile;
                   InitializeOwlPop(Owls);
                   TimeSeries(Ct,Owls,BoundFile, Extinct);
                   MultipleOutput(Ct,OutF);
                END;
                Close(OutF);
                Close(MOFile);
                CreateSummaryStats(MTE,PairDistance,DeathDistance,MinPop);
                KillTempFile;
END;
{**************Main Program**********}

BEGIN
     ZeroFill(MTE,SizeOF(MTE));
     MinPop := 65535;
     MultRuns := False;
     Dynamic := False;
     Extinct := FALSE;
     Device := 0;
     Mode   := 0;
     YrCtr  := 0;
     GraphOn := FALSE;
     GlobalDelay := 20;
     SetColors;
     SimSetColors;
     RetrieveFile(Video1,-9999,TRUE,Error);
     IF Error THEN
        FatalErrors(4);
     PickUpRules;
     Dynamic := ChooseDynamicMaps(BoundFile);
     IF Runs > 1 THEN
        MultipleRuns
     ELSE BEGIN
          GraphOn := ChooseGraphics;
          InitializePop(Owls,Error);
          IF Error THEN
             FatalErrors(5);
          InitializeOwlPop(Owls);
          Randomize;
          TimeSeries(1,Owls,BoundFile,Extinct);
          IF GraphOn THEN
             RestoreTextMode;
          OutputMenu(SimAgain);
          IF GraphOn THEN
             CloseGraph;
     END;
     HaltProgram;
END.

